;<ff
Window frmMain, 3, 0, 'TForm', 'SQLite simple example', $16080000, $10000, 0, 257, 216, 434, 312, MainFormWinProc;
Window NONE, 0, 1, 'LISTBOX', 'Listbox', $50800141, $200, 100, 0, 0, 136, 285, 0;
Window NONE, 2, 5, 'STATIC', 'Image', $5000120E, $0, 101, 136, 0, 290, 285, 0;
;ff>
idListBox = 100
idImage   = 101

idMainIcon = 2
idDefaultImage = 1

uglobal
  ptrDatabase dd ?
  hSQL        dd ?
  ptrDummy    dd ?
endg


winproc MainFormWinProc
begin

ondefault
        stc
        return

onmessage FM_AFTERCREATE
; Set main window icons
        invoke  LoadImageA, [hInstance], idMainIcon, IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR
        invoke  SendMessageA, [.hwnd], WM_SETICON, ICON_SMALL, eax
        invoke  LoadImageA, [hInstance], idMainIcon, IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR
        invoke  SendMessageA, [.hwnd], WM_SETICON, ICON_BIG, eax

; set default image.
        invoke  LoadImageA, [hInstance], idDefaultImage, IMAGE_BITMAP, 0, 0, 0
        invoke  SendDlgItemMessageA, [.hwnd], idImage, STM_SETIMAGE, IMAGE_BITMAP, eax

; Open the images database
iglobal
  cDBName db 'pictures.sqlite', 0
endg
        cinvoke sqliteOpen, cDBName, ptrDatabase

; Read the list of the images in the database and fill the listbox with names and ID's of the images.
iglobal
  sqlSelectNames db 'select ID, Name from Pictures order by FromSun',0
endg
        cinvoke sqlitePrepare, [ptrDatabase], sqlSelectNames, -1, hSQL, ptrDummy
.loop:
        cinvoke sqliteStep, [hSQL]
        cmp     eax, SQLITE_ROW
        jne     .endloop

        cinvoke sqliteColumnInt, [hSQL], 0      ; ID
        mov     ebx, eax
        cinvoke sqliteColumnText, [hSQL], 1     ; Name

        invoke  SendDlgItemMessageA, [.hwnd], idListBox, LB_ADDSTRING, 0, eax
        cmp     eax, LB_ERR
        je      .loop
        invoke  SendDlgItemMessageA, [.hwnd], idListBox, LB_SETITEMDATA, eax, ebx
        jmp     .loop

.endloop:
        cinvoke sqliteFinalize, [hSQL]
        clc
        return

onmessage WM_DESTROY
        cinvoke sqliteClose, [ptrDatabase]
        xor     eax, eax
        clc
        return



onmessage WM_COMMAND
locals
  .ptrBits dd ?
endl
        cmp     word [.wparam], idListBox          ; ID of the control that sends the message.
        jne     .ondefault

        cmp     word [.wparam+2], LBN_SELCHANGE
        jne     .ondefault

; The selection in the listbox were changed, so read the image from database and assign it to
; the static control at the right (idImage)
iglobal
  sqlGetPicture  db 'select Picture from Pictures where ID = ?', 0
endg
        cinvoke sqlitePrepare, [ptrDatabase], sqlGetPicture, -1, hSQL, ptrDummy

        invoke  SendDlgItemMessageA, [.hwnd], idListBox, LB_GETCURSEL, 0, 0
        cmp     eax, LB_ERR
        je      .finalize
        invoke  SendDlgItemMessageA, [.hwnd], idListBox, LB_GETITEMDATA, eax, 0

        cinvoke sqliteBindInt, [hSQL], 1, eax
        cinvoke sqliteStep, [hSQL]

        cinvoke sqliteColumnBytes, [hSQL], 0
        mov     ebx, eax

        cinvoke sqliteColumnBlob, [hSQL], 0
        mov     esi, eax

; Here you can see how to read bitmap directly from the memory, not from resource or file...
        lea     eax, [esi+14]   ; start of the BITMAPINFOHEADER
        lea     ecx, [.ptrBits]
        invoke  CreateDIBSection, 0, eax, 0, ecx, 0, 0

        push    eax     ; store the handle in the stack for future processing...

        xor     eax, eax
        movzx   ecx, [esi+sizeof.BITMAPFILEHEADER+BITMAPINFOHEADER.biBitCount]
        cmp     ecx, 8
        ja      .paletteok

        mov     eax, 1
        add     ecx, 2  ; every palette item is 4 bytes
        shl     eax, cl

.paletteok:
        lea     esi, [esi + sizeof.BITMAPFILEHEADER + sizeof.BITMAPINFOHEADER + eax]
        lea     ecx, [ebx - sizeof.BITMAPFILEHEADER - sizeof.BITMAPINFOHEADER]
        sub     ecx, eax

        shr     ecx, 2

        mov     edi, [.ptrBits]
        rep movsd

        invoke  SendDlgItemMessageA, [.hwnd], idImage, STM_SETIMAGE, IMAGE_BITMAP ; handle from the stack
        test    eax, eax
        jz      .finalize

        invoke  DeleteObject, eax ; delete the previous selected image

.finalize:
        cinvoke sqliteFinalize, [hSQL]    ; don't forget to finalize SQL statements.
        xor     eax, eax
        clc
        return

endwp
