; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: SQLite equates definitions.
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________

; SQLite result codes

SQLITE_OK         =  0   ; Successful result
SQLITE_ERROR      =  1   ; SQL error or missing database
SQLITE_INTERNAL   =  2   ; An internal logic error in SQLite
SQLITE_PERM       =  3   ; Access permission denied
SQLITE_ABORT      =  4   ; Callback routine requested an abort
SQLITE_BUSY       =  5   ; The database file is locked
SQLITE_LOCKED     =  6   ; A table in the database is locked
SQLITE_NOMEM      =  7   ; A malloc() failed
SQLITE_READONLY   =  8   ; Attempt to write a readonly database
SQLITE_INTERRUPT  =  9   ; Operation terminated by sqlite_interrupt()
SQLITE_IOERR      = 10   ; Some kind of disk I/O error occurred
SQLITE_CORRUPT    = 11   ; The database disk image is malformed
SQLITE_NOTFOUND   = 12   ; (Internal Only) Table or record not found
SQLITE_FULL       = 13   ; Insertion failed because database is full
SQLITE_CANTOPEN   = 14   ; Unable to open the database file
SQLITE_PROTOCOL   = 15   ; Database lock protocol error
SQLITE_EMPTY      = 16   ; (Internal Only) Database table is empty
SQLITE_SCHEMA     = 17   ; The database schema changed
SQLITE_TOOBIG     = 18   ; Too much data for one row of a table
SQLITE_CONSTRAINT = 19   ; Abort due to constraint violation
SQLITE_MISMATCH   = 20   ; Data type mismatch
SQLITE_MISUSE     = 21   ; Library used incorrectly
SQLITE_NOLFS      = 22   ; Uses OS features not supported on host
SQLITE_AUTH       = 23   ; Authorization denied
SQLITE_ROW        = 100  ; sqlite_step() has another row ready
SQLITE_DONE       = 101  ; sqlite_step() has finished executing


SQLITE_CREATE_INDEX        =  1 ;   // Index Name      Table Name      */
SQLITE_CREATE_TABLE        =  2 ;   // Table Name      NULL            */
SQLITE_CREATE_TEMP_INDEX   =  3 ;   // Index Name      Table Name      */
SQLITE_CREATE_TEMP_TABLE   =  4 ;   // Table Name      NULL            */
SQLITE_CREATE_TEMP_TRIGGER =  5 ;   // Trigger Name    Table Name      */
SQLITE_CREATE_TEMP_VIEW    =  6 ;   // View Name       NULL            */
SQLITE_CREATE_TRIGGER      =  7 ;   // Trigger Name    Table Name      */
SQLITE_CREATE_VIEW         =  8 ;   // View Name       NULL            */
SQLITE_DELETE              =  9 ;   // Table Name      NULL            */
SQLITE_DROP_INDEX          = 10 ;   // Index Name      Table Name      */
SQLITE_DROP_TABLE          = 11 ;   // Table Name      NULL            */
SQLITE_DROP_TEMP_INDEX     = 12 ;   // Index Name      Table Name      */
SQLITE_DROP_TEMP_TABLE     = 13 ;   // Table Name      NULL            */
SQLITE_DROP_TEMP_TRIGGER   = 14 ;   // Trigger Name    Table Name      */
SQLITE_DROP_TEMP_VIEW      = 15 ;   // View Name       NULL            */
SQLITE_DROP_TRIGGER        = 16 ;   // Trigger Name    Table Name      */
SQLITE_DROP_VIEW           = 17 ;   // View Name       NULL            */
SQLITE_INSERT              = 18 ;   // Table Name      NULL            */
SQLITE_PRAGMA              = 19 ;   // Pragma Name     1st arg or NULL */
SQLITE_READ                = 20 ;   // Table Name      Column Name     */
SQLITE_SELECT              = 21 ;   // NULL            NULL            */
SQLITE_TRANSACTION         = 22 ;   // NULL            NULL            */
SQLITE_UPDATE              = 23 ;   // Table Name      Column Name     */
SQLITE_ATTACH              = 24 ;   // Filename        NULL            */
SQLITE_DETACH              = 25 ;   // Database Name   NULL            */

SQLITE_DENY   = 1       ;   // Abort the SQL statement with an error */
SQLITE_IGNORE = 2       ;   // Don't allow access, but don't generate an error */


; These are the allowed values for the eTextRep argument to
; sqliteCreateCollation and sqliteCreateFunction.

SQLITE_UTF8       = 1
SQLITE_UTF16LE    = 2
SQLITE_UTF16BE    = 3
SQLITE_UTF16      = 4   ;   Use native byte order
SQLITE_ANY        = 5

; values returned by sqliteColumnType
SQLITE_INTEGER    = 1
SQLITE_FLOAT      = 2
SQLITE_TEXT       = 3
SQLITE_BLOB       = 4
SQLITE_NULL       = 5


SQLITE_STATIC     = 0
SQLITE_TRANSIENT  = -1