; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: Provides raster bitmap, to be used for double buffer painting.
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________



proc CreateBackBuffer, .hwin, .width, .height
begin
        push    ebx ecx edx

        stdcall GetMem, sizeof.TBackBuffer
        mov     ebx, eax

        mov     ecx, [.width]
        mov     edx, [.height]

        xor     eax, eax
        inc     eax

        cmp     ecx, eax
        jge     @f
        mov     ecx, eax
@@:
        cmp     edx, eax
        jge     @f
        mov     edx, eax
@@:
        mov     [ebx+TBackBuffer.width], ecx
        mov     [ebx+TBackBuffer.height], edx

        cinvoke XCreatePixmap, [hApplicationDisplay], [.hwin], [ebx+TBackBuffer.width], [ebx+TBackBuffer.height], 24
        mov     [ebx+TBackBuffer.raster], eax
        mov     eax, ebx
        pop     edx ecx ebx
        return
endp




proc DestroyBackBuffer, .pBackBuffer
begin
        push    eax ecx edx
        mov     eax, [.pBackBuffer]
        push    eax
        cinvoke XFreePixmap, [hApplicationDisplay], [eax+TBackBuffer.raster]
        stdcall FreeMem ; from the stack
        pop     edx ecx eax
        return
endp






proc DrawBackBuffer, .context, .pBackBuffer, .x, .y
begin
        push    eax ecx edx
        mov     eax, [.pBackBuffer]
        mov     ecx, [.context]

        cinvoke XCopyArea, [hApplicationDisplay], [eax+TBackBuffer.raster], [ecx+TContext.raster], [ecx+TContext.handle], 0, 0, [eax+TBackBuffer.width], [eax+TBackBuffer.height], [.x], [.y]

        pop     edx ecx eax
        return
endp

