; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: Memory based images manipulation library.
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes: Include respective OS dependent files.
;_________________________________________________________________________________________
module "Images library"

struct TImage
  .width  dd ?  ; width in pixels.
  .height dd ?  ; height in pixels.
  .bpp    dd ?  ; bits per pixel.
  .pData  dd ?  ; pointer to memory buffer with scanlines. all scanlines are aligned on dword.
  .raster dd ?  ; OS handle to be used with procedures from other graphics libraries.
ends


proc DrawMaskedImage, .context, .mask, .image, .x, .y
begin
        stdcall SetDrawMode, [.context], cmAnd
        stdcall DrawImage, [.context], [.mask], [.x], [.y]
        stdcall SetDrawMode, [.context], cmXor
        stdcall DrawImage, [.context], [.image], [.x], [.y]
        return
endp


include '%TargetOS%/images.asm'

endmodule