; This macro aims to provide some limited use of the old visual editor
; with the new template engine, until the new one is created.

macro __define_one_property property {
  match id==value, property \{
         dd id
         if value eqtype 2
            dd  value
         else
            dd  ..txt
         end if
    ..txt text value
  \}
}



macro Window  name, flags, walign, class, txt, style, styleEx, ID, left, top, width, height, [props] {
common
  local ..paramsize, ..prms, ..caption, ..name, ..subtype, ..txtalign, ..class

  ..subtype = style and $0f

  ..txtalign = 0

  if ~name eq NONE
     name#.template#:
  end if

  ; flags
       dd    flags      ; the values are the same

  ..class = CWindow

  ; class
  if class eq 'TForm'
    ..class = CForm
  else
    if class eq 'BUTTON'

      if ..subtype = 0  ; BS_PUSHBUTTON
        ..class = CButton
        ..txtalign = dtfAlignCenter or dtfAlignMiddle
      end if

      if ..subtype = 2  ; BS_CHECKBOX
        ..class = CCheckBox
      end if

      if ..subtype = 4  ; BS_RADIOBUTTON
        ..class = CRadioButton
      end if

    else

       if class eq 'EDIT'
         if (style and 4)  ;ES_MULTILINE
           ..class = CFreshEdit    ; it is not good to use CFreshEdit, but we don't have light multiline edit.
         else
           ..class = CEdit
         end if
       else

         if class eq 'STATIC'
           ..class = CLabel

           if ..subtype = 1     ; SS_CENTER
             ..txtalign = ..txtalign or dtfAlignCenter
           end if

           if ..subtype = 2     ; SS_RIGHT
             ..txtalign = ..txtalign or dtfAlignCenter
           end if

           if (style and $200) ;SS_CENTERIMAGE
             ..txtalign = ..txtalign or dtfAlignMiddle
           end if

         else
           if class eq 'msctls_progress32'
             ..class = CProgress
           end if
         end if
       end if

    end if
  end if

  dd ..class

  ; name
  if name eq NONE
        dd  ..name
  else
        dd  name
  end if

  ;parameters size
        dd ..paramsize

..prms:
        dd      TWindow.Align
        dd      walign

        dd      TWindow.x
        dd      left

        dd      TWindow.y
        dd      top

        dd      TWindow.width
        dd      width

        dd      TWindow.height
        dd      height

        if (..class = CForm)|(..class = CButton)|(..class = CLabel)
          dd      TWindow.Caption
        else
          if ..class = CEdit
            dd TEdit.Text
          else
            dd TFreshEdit.Text
          end if
        end if
        dd      ..caption

  if (style and $10000000) <> 0   ; WS_VISIBLE
        dd      TWindow.Visible
        dd      1
  end if

  if ..txtalign
    if ..class = CButton
        dd      TButton.TextAlign
    else
        dd      TLabel.TextAlign
    end if
        dd      ..txtalign
  end if
forward
       __define_one_property props

common
       dd  -1   ; end of params

  if name eq NONE
    ..name dd ?
  else
    name dd ?
  end if

  ..paramsize = $ - ..prms

..caption text txt

}
