; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: TForm object class
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes: Represents form window that to serve as parent window for other controls.
;_________________________________________________________________________________________
module "TForm library"


ObjectClass Form,                       \
            Window,                     \
            0,                          \       ;TForm.Create,               \
            0,                          \
            TForm.Get,                  \
            TForm.Set,                  \
            0,                          \
            TForm.SysEventHandler


mrNone   = 0
mrOK     = 1
mrCancel = 2
mrAbort  = 3
mrRetry  = 4
mrIgnore = 5
mrYes    = 6
mrNo     = 7
mrMaybe  = 8


object TForm, TWindow

  .ModalResult  dd ?

  .OnClose dd ?         ; On close window event handler.

  param .type
endobj


proc TForm.Create, .obj
begin
;        stdcall Set, [.obj], TWindow.borderKind, borderFull
        return
endp


; OS independent code.

proc TForm.Get, .obj, .paramID
begin
        stc
        return
endp



proc TForm.Set, .obj, .paramID, .value
begin
        stc
        return
endp



proc TForm.SysEventHandler, .pObj, .pEvent
begin
        push    ebx esi
        mov     ebx, [.pEvent]
        cmp     [ebx+TSysEvent.event], sePaint
        je      .onpaint

        cmp     [ebx+TSysEvent.event], seCloseRequest
        je      .close_request

.finish:
        stc
        pop     esi ebx
        return

.onpaint:
        mov     esi, [.pObj]

        mov     eax, [esi+TWindow._width]
        mov     ecx, [esi+TWindow._height]

        stdcall DrawFillRect, [ebx+TPaintEvent.context], 0, 0, eax, ecx, [clDialogBk]
        jmp     .finish

.close_request:
;        DebugMsg "Close request"
        cmp     [esi+TForm.OnClose], 0
        je      @f

        stdcall [esi+TForm.OnClose], esi, [ebx+TCloseEvent.reason]      ; if OnClose return CF=0 the form is destroyed. Else, the form is not destroyed.
        jc      .finish

@@:
        stdcall Set, [.pObj], TForm.Visible, FALSE
        stdcall Destroy, [.pObj]

        DebugMsg "Form destroyed"

.destroyed:
        clc
        pop     esi ebx
        return
endp


endmodule
