; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: gdi32.dll API calls
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________

import_proto gdi32,  \
    AbortDoc, <.hdc>,  'AbortDoc',  \
    AbortPath, <.hdc>,  'AbortPath',  \
    AddFontMemResourceEx, <.pvoid, .dword, .pDword>,  'AddFontMemResourceEx',  \
    AddFontResourceA, <.lpFileName>,  'AddFontResourceA',  \
    AddFontResourceExA, <.lpcstr, .dword>,  'AddFontResourceExA',  \
    AddFontResourceExW, <.lpcstr, .dword>,  'AddFontResourceExW',  \
    AddFontResourceTracking, <NONE>,  'AddFontResourceTracking',  \
    AddFontResourceW, <.lpFileName>,  'AddFontResourceW',  \
    AngleArc, <.hdc, .x, .y, .dwRadius, .eStartAngle, .eSweepAngle>,  'AngleArc',  \
    AnimatePalette, <.hPalette, .wStartIndex, .wNumEntries, .lpPaletteColors>,  'AnimatePalette',  \
    AnyLinkedFonts, <NONE>,  'AnyLinkedFonts',  \
    Arc, <.hdc, .X1, .Y1, .X2, .Y2, .X3, .Y3, .X4, .Y4>,  'Arc',  \
    ArcTo, <.hdc, .X1, .Y1, .X2, .Y2, .X3, .Y3, .X4, .Y4>,  'ArcTo',  \
    BRUSHOBJ_hGetColorTransform, <NONE>,  'BRUSHOBJ_hGetColorTransform',  \
    BRUSHOBJ_pvAllocRbrush, <NONE>,  'BRUSHOBJ_pvAllocRbrush',  \
    BRUSHOBJ_pvGetRbrush, <NONE>,  'BRUSHOBJ_pvGetRbrush',  \
    BRUSHOBJ_ulGetBrushColor, <NONE>,  'BRUSHOBJ_ulGetBrushColor',  \
    BeginPath, <.hdc>,  'BeginPath',  \
    BitBlt, <.hDestDC, .x, .y, .nWidth, .nHeight, .hSrcDC, .xSrc, .ySrc, .dwRop>,  'BitBlt',  \
    CLIPOBJ_bEnum, <NONE>,  'CLIPOBJ_bEnum',  \
    CLIPOBJ_cEnumStart, <NONE>,  'CLIPOBJ_cEnumStart',  \
    CLIPOBJ_ppoGetPath, <NONE>,  'CLIPOBJ_ppoGetPath',  \
    CancelDC, <.hdc>,  'CancelDC',  \
    CheckColorsInGamut, <.hdc, .lpv, .lpv2, .dw>,  'CheckColorsInGamut',  \
    ChoosePixelFormat, <.hDC, .pPixelFormatDescriptor>,  'ChoosePixelFormat',  \
    Chord, <.hdc, .X1, .Y1, .X2, .Y2, .X3, .Y3, .X4, .Y4>,  'Chord',  \
    ClearBitmapAttributes, <NONE>,  'ClearBitmapAttributes',  \
    ClearBrushAttributes, <NONE>,  'ClearBrushAttributes',  \
    CloseEnhMetaFile, <.hdc>,  'CloseEnhMetaFile',  \
    CloseFigure, <.hdc>,  'CloseFigure',  \
    CloseMetaFile, <.hMF>,  'CloseMetaFile',  \
    ColorCorrectPalette, <.hdc, .hpalette, .dword>,  'ColorCorrectPalette',  \
    ColorMatchToTarget, <.hdc, .hdc2, .dw>,  'ColorMatchToTarget',  \
    CombineRgn, <.hDestRgn, .hSrcRgn1, .hSrcRgn2, .nCombineMode>,  'CombineRgn',  \
    CombineTransform, <.lpxformResult, .lpxform1, .lpxform2>,  'CombineTransform',  \
    CopyEnhMetaFileA, <.hemfSrc, .lpszFile>,  'CopyEnhMetaFileA',  \
    CopyEnhMetaFileW, <.hemfSrc, .lpszFile>,  'CopyEnhMetaFileW',  \
    CopyMetaFileA, <.hMF, .lpFileName>,  'CopyMetaFileA',  \
    CopyMetaFileW, <.hMF, .lpFileName>,  'CopyMetaFileW',  \
    CreateBitmap, <.nWidth, .nHeight, .nPlanes, .nBitCount, .lpBits>,  'CreateBitmap',  \
    CreateBitmapIndirect, <.lpBitmap>,  'CreateBitmapIndirect',  \
    CreateBrushIndirect, <.lpLogBrush>,  'CreateBrushIndirect',  \
    CreateColorSpaceA, <.lplogcolorspace>,  'CreateColorSpaceA',  \
    CreateColorSpaceW, <.lplogcolorspace>,  'CreateColorSpaceW',  \
    CreateCompatibleBitmap, <.hdc, .nWidth, .nHeight>,  'CreateCompatibleBitmap',  \
    CreateCompatibleDC, <.hdc>,  'CreateCompatibleDC',  \
    CreateDCA, <.lpDriverName, .lpDeviceName, .lpOutput, .lpInitData>,  'CreateDCA',  \
    CreateDCW, <.lpDriverName, .lpDeviceName, .lpOutput, .lpInitData>,  'CreateDCW',  \
    CreateDIBPatternBrush, <.hPackedDIB, .wUsage>,  'CreateDIBPatternBrush',  \
    CreateDIBPatternBrushPt, <.lpPackedDIB, .iUsage>,  'CreateDIBPatternBrushPt',  \
    CreateDIBSection, <.hDC, .pBitmapInfo, .un, .lplpVoid, .handle, .dw>,  'CreateDIBSection',  \
    CreateDIBitmap, <.hdc, .lpInfoHeader, .dwUsage, .lpInitBits, .lpInitInfo, .wUsage>,  'CreateDIBitmap',  \
    CreateDiscardableBitmap, <.hdc, .nWidth, .nHeight>,  'CreateDiscardableBitmap',  \
    CreateEllipticRgn, <.X1, .Y1, .X2, .Y2>,  'CreateEllipticRgn',  \
    CreateEllipticRgnIndirect, <.lpRect>,  'CreateEllipticRgnIndirect',  \
    CreateEnhMetaFileA, <.hdcRef, .lpFileName, .lpRect, .lpDescription>,  'CreateEnhMetaFileA',  \
    CreateEnhMetaFileW, <.hdcRef, .lpFileName, .lpRect, .lpDescription>,  'CreateEnhMetaFileW',  \
    CreateFontA, <.H, .W, .E, .O, .I, .u, .S, .C, .OP, .CP, .Q, .PAF, .F>,  'CreateFontA',  \
    CreateFontIndirectA, <.lpLogFont>,  'CreateFontIndirectA',  \
    CreateFontIndirectExA, <.ENUMLOGFONTEXDVA>,  'CreateFontIndirectExA',  \
    CreateFontIndirectExW, <.ENUMLOGFONTEXDVA>,  'CreateFontIndirectExW',  \
    CreateFontIndirectW, <.lpLogFont>,  'CreateFontIndirectW',  \
    CreateFontW, <.H, .W, .E, .O, .I, .u, .S, .C, .OP, .CP, .Q, .PAF, .F>,  'CreateFontW',  \
    CreateHalftonePalette, <.hdc>,  'CreateHalftonePalette',  \
    CreateHatchBrush, <.nIndex, .crColor>,  'CreateHatchBrush',  \
    CreateICA, <.lpDriverName, .lpDeviceName, .lpOutput, .lpInitData>,  'CreateICA',  \
    CreateICW, <.lpDriverName, .lpDeviceName, .lpOutput, .lpInitData>,  'CreateICW',  \
    CreateMetaFileA, <.lpString>,  'CreateMetaFileA',  \
    CreateMetaFileW, <.lpString>,  'CreateMetaFileW',  \
    CreatePalette, <.lpLogPalette>,  'CreatePalette',  \
    CreatePatternBrush, <.hBitmap>,  'CreatePatternBrush',  \
    CreatePen, <.nPenStyle, .nWidth, .crColor>,  'CreatePen',  \
    CreatePenIndirect, <.lpLogPen>,  'CreatePenIndirect',  \
    CreatePolyPolygonRgn, <.lpPoint, .lpPolyCounts, .nCount, .nPolyFillMode>,  'CreatePolyPolygonRgn',  \
    CreatePolygonRgn, <.lpPoint, .nCount, .nPolyFillMode>,  'CreatePolygonRgn',  \
    CreateRectRgn, <.X1, .Y1, .X2, .Y2>,  'CreateRectRgn',  \
    CreateRectRgnIndirect, <.lpRect>,  'CreateRectRgnIndirect',  \
    CreateRoundRectRgn, <.X1, .Y1, .X2, .Y2, .X3, .Y3>,  'CreateRoundRectRgn',  \
    CreateScalableFontResourceA, <.fHidden, .lpszResourceFile, .lpszFontFile, .lpszCurrentPath>,  'CreateScalableFontResourceA',  \
    CreateScalableFontResourceW, <.fHidden, .lpszResourceFile, .lpszFontFile, .lpszCurrentPath>,  'CreateScalableFontResourceW',  \
    CreateSolidBrush, <.crColor>,  'CreateSolidBrush',  \
    DPtoLP, <.hdc, .lpPoint, .nCount>,  'DPtoLP',  \
    DdEntry0, <NONE>,  'DdEntry0',  \
    DdEntry1, <NONE>,  'DdEntry1',  \
    DdEntry10, <NONE>,  'DdEntry10',  \
    DdEntry11, <NONE>,  'DdEntry11',  \
    DdEntry12, <NONE>,  'DdEntry12',  \
    DdEntry13, <NONE>,  'DdEntry13',  \
    DdEntry14, <NONE>,  'DdEntry14',  \
    DdEntry15, <NONE>,  'DdEntry15',  \
    DdEntry16, <NONE>,  'DdEntry16',  \
    DdEntry17, <NONE>,  'DdEntry17',  \
    DdEntry18, <NONE>,  'DdEntry18',  \
    DdEntry19, <NONE>,  'DdEntry19',  \
    DdEntry2, <NONE>,  'DdEntry2',  \
    DdEntry20, <NONE>,  'DdEntry20',  \
    DdEntry21, <NONE>,  'DdEntry21',  \
    DdEntry22, <NONE>,  'DdEntry22',  \
    DdEntry23, <NONE>,  'DdEntry23',  \
    DdEntry24, <NONE>,  'DdEntry24',  \
    DdEntry25, <NONE>,  'DdEntry25',  \
    DdEntry26, <NONE>,  'DdEntry26',  \
    DdEntry27, <NONE>,  'DdEntry27',  \
    DdEntry28, <NONE>,  'DdEntry28',  \
    DdEntry29, <NONE>,  'DdEntry29',  \
    DdEntry3, <NONE>,  'DdEntry3',  \
    DdEntry30, <NONE>,  'DdEntry30',  \
    DdEntry31, <NONE>,  'DdEntry31',  \
    DdEntry32, <NONE>,  'DdEntry32',  \
    DdEntry33, <NONE>,  'DdEntry33',  \
    DdEntry34, <NONE>,  'DdEntry34',  \
    DdEntry35, <NONE>,  'DdEntry35',  \
    DdEntry36, <NONE>,  'DdEntry36',  \
    DdEntry37, <NONE>,  'DdEntry37',  \
    DdEntry38, <NONE>,  'DdEntry38',  \
    DdEntry39, <NONE>,  'DdEntry39',  \
    DdEntry4, <NONE>,  'DdEntry4',  \
    DdEntry40, <NONE>,  'DdEntry40',  \
    DdEntry41, <NONE>,  'DdEntry41',  \
    DdEntry42, <NONE>,  'DdEntry42',  \
    DdEntry43, <NONE>,  'DdEntry43',  \
    DdEntry44, <NONE>,  'DdEntry44',  \
    DdEntry45, <NONE>,  'DdEntry45',  \
    DdEntry46, <NONE>,  'DdEntry46',  \
    DdEntry47, <NONE>,  'DdEntry47',  \
    DdEntry48, <NONE>,  'DdEntry48',  \
    DdEntry49, <NONE>,  'DdEntry49',  \
    DdEntry5, <NONE>,  'DdEntry5',  \
    DdEntry50, <NONE>,  'DdEntry50',  \
    DdEntry51, <NONE>,  'DdEntry51',  \
    DdEntry52, <NONE>,  'DdEntry52',  \
    DdEntry53, <NONE>,  'DdEntry53',  \
    DdEntry54, <NONE>,  'DdEntry54',  \
    DdEntry55, <NONE>,  'DdEntry55',  \
    DdEntry56, <NONE>,  'DdEntry56',  \
    DdEntry6, <NONE>,  'DdEntry6',  \
    DdEntry7, <NONE>,  'DdEntry7',  \
    DdEntry8, <NONE>,  'DdEntry8',  \
    DdEntry9, <NONE>,  'DdEntry9',  \
    DeleteColorSpace, <.hcolorspace>,  'DeleteColorSpace',  \
    DeleteDC, <.hdc>,  'DeleteDC',  \
    DeleteEnhMetaFile, <.hemf>,  'DeleteEnhMetaFile',  \
    DeleteMetaFile, <.hMF>,  'DeleteMetaFile',  \
    DeleteObject, <.hObject>,  'DeleteObject',  \
    DescribePixelFormat, <.hDC, .n, .un, .lpPixelFormatDescriptor>,  'DescribePixelFormat',  \
    DeviceCapabilitiesExA, <NONE>,  'DeviceCapabilitiesExA',  \
    DeviceCapabilitiesExW, <NONE>,  'DeviceCapabilitiesExW',  \
    DrawEscape, <.hdc, .nEscape, .cbInput, .lpszInData>,  'DrawEscape',  \
    Ellipse, <.hdc, .X1, .Y1, .X2, .Y2>,  'Ellipse',  \
    EnableEUDC, <NONE>,  'EnableEUDC',  \
    EndDoc, <.hDC>,  'EndDoc',  \
    EndFormPage, <.hdc>,  'EndFormPage',  \
    EndPage, <.hdc>,  'EndPage',  \
    EndPath, <.hdc>,  'EndPath',  \
    EngAcquireSemaphore, <NONE>,  'EngAcquireSemaphore',  \
    EngAlphaBlend, <NONE>,  'EngAlphaBlend',  \
    EngAssociateSurface, <NONE>,  'EngAssociateSurface',  \
    EngBitBlt, <NONE>,  'EngBitBlt',  \
    EngCheckAbort, <NONE>,  'EngCheckAbort',  \
    EngComputeGlyphSet, <NONE>,  'EngComputeGlyphSet',  \
    EngCopyBits, <NONE>,  'EngCopyBits',  \
    EngCreateBitmap, <NONE>,  'EngCreateBitmap',  \
    EngCreateClip, <NONE>,  'EngCreateClip',  \
    EngCreateDeviceBitmap, <NONE>,  'EngCreateDeviceBitmap',  \
    EngCreateDeviceSurface, <NONE>,  'EngCreateDeviceSurface',  \
    EngCreatePalette, <NONE>,  'EngCreatePalette',  \
    EngCreateSemaphore, <NONE>,  'EngCreateSemaphore',  \
    EngDeleteClip, <NONE>,  'EngDeleteClip',  \
    EngDeletePalette, <NONE>,  'EngDeletePalette',  \
    EngDeletePath, <NONE>,  'EngDeletePath',  \
    EngDeleteSemaphore, <NONE>,  'EngDeleteSemaphore',  \
    EngDeleteSurface, <NONE>,  'EngDeleteSurface',  \
    EngEraseSurface, <NONE>,  'EngEraseSurface',  \
    EngFillPath, <NONE>,  'EngFillPath',  \
    EngFindResource, <NONE>,  'EngFindResource',  \
    EngFreeModule, <NONE>,  'EngFreeModule',  \
    EngGetCurrentCodePage, <NONE>,  'EngGetCurrentCodePage',  \
    EngGetDriverName, <NONE>,  'EngGetDriverName',  \
    EngGetPrinterDataFileName, <NONE>,  'EngGetPrinterDataFileName',  \
    EngGradientFill, <NONE>,  'EngGradientFill',  \
    EngLineTo, <NONE>,  'EngLineTo',  \
    EngLoadModule, <NONE>,  'EngLoadModule',  \
    EngLockSurface, <NONE>,  'EngLockSurface',  \
    EngMarkBandingSurface, <NONE>,  'EngMarkBandingSurface',  \
    EngMultiByteToUnicodeN, <NONE>,  'EngMultiByteToUnicodeN',  \
    EngMultiByteToWideChar, <NONE>,  'EngMultiByteToWideChar',  \
    EngPaint, <NONE>,  'EngPaint',  \
    EngPlgBlt, <NONE>,  'EngPlgBlt',  \
    EngQueryEMFInfo, <NONE>,  'EngQueryEMFInfo',  \
    EngQueryLocalTime, <NONE>,  'EngQueryLocalTime',  \
    EngReleaseSemaphore, <NONE>,  'EngReleaseSemaphore',  \
    EngStretchBlt, <NONE>,  'EngStretchBlt',  \
    EngStretchBltROP, <NONE>,  'EngStretchBltROP',  \
    EngStrokeAndFillPath, <NONE>,  'EngStrokeAndFillPath',  \
    EngStrokePath, <NONE>,  'EngStrokePath',  \
    EngTextOut, <NONE>,  'EngTextOut',  \
    EngTransparentBlt, <NONE>,  'EngTransparentBlt',  \
    EngUnicodeToMultiByteN, <NONE>,  'EngUnicodeToMultiByteN',  \
    EngUnlockSurface, <NONE>,  'EngUnlockSurface',  \
    EngWideCharToMultiByte, <NONE>,  'EngWideCharToMultiByte',  \
    EnumEnhMetaFile, <.hdc, .hemf, .lpEnhMetaFunc, .lpData, .lpRect>,  'EnumEnhMetaFile',  \
    EnumFontFamiliesA, <.hdc, .lpszFamily, .lpEnumFontFamProc, .lParam>,  'EnumFontFamiliesA',  \
    EnumFontFamiliesExA, <.hdc, .lpLogFont, .lpEnumFontProc, .lParam, .dw>,  'EnumFontFamiliesExA',  \
    EnumFontFamiliesExW, <.hdc, .lpLogFont, .lpEnumFontProc, .lParam, .dw>,  'EnumFontFamiliesExW',  \
    EnumFontFamiliesW, <.hdc, .lpszFamily, .lpEnumFontFamProc, .lParam>,  'EnumFontFamiliesW',  \
    EnumFontsA, <.hDC, .lpsz, .lpFontEnumProc, .lParam>,  'EnumFontsA',  \
    EnumFontsW, <.hDC, .lpsz, .lpFontEnumProc, .lParam>,  'EnumFontsW',  \
    EnumICMProfilesA, <.hdc, .icmEnumProc, .lParam>,  'EnumICMProfilesA',  \
    EnumICMProfilesW, <.hdc, .icmEnumProc, .lParam>,  'EnumICMProfilesW',  \
    EnumMetaFile, <.hDC, .hMetafile, .lpMFEnumProc, .lParam>,  'EnumMetaFile',  \
    EnumObjects, <.hDC, .n, .lpGOBJEnumProc, .lpVoid>,  'EnumObjects',  \
    EqualRgn, <.hSrcRgn1, .hSrcRgn2>,  'EqualRgn',  \
    Escape, <.hdc, .nEscape, .nCount, .lpInData, .lpOutData>,  'Escape',  \
    EudcLoadLinkW, <NONE>,  'EudcLoadLinkW',  \
    EudcUnloadLinkW, <NONE>,  'EudcUnloadLinkW',  \
    ExcludeClipRect, <.hdc, .X1, .Y1, .X2, .Y2>,  'ExcludeClipRect',  \
    ExtCreatePen, <.dwPenStyle, .dwWidth, .lplb, .dwStyleCount, .lpStyle>,  'ExtCreatePen',  \
    ExtCreateRegion, <.lpXform, .nCount, .lpRgnData>,  'ExtCreateRegion',  \
    ExtEscape, <.hdc, .nEscape, .cbInput, .lpszInData, .cbOutput, .lpszOutData>,  'ExtEscape',  \
    ExtFloodFill, <.hdc, .x, .y, .crColor, .wFillType>,  'ExtFloodFill',  \
    ExtSelectClipRgn, <.hdc, .hRgn, .fnMode>,  'ExtSelectClipRgn',  \
    ExtTextOutA, <.hdc, .x, .y, .wOptions, .lpRect, .lpString, .nCount, .lpDx>,  'ExtTextOutA',  \
    ExtTextOutW, <.hdc, .x, .y, .wOptions, .lpRect, .lpString, .nCount, .lpDx>,  'ExtTextOutW',  \
    FONTOBJ_cGetAllGlyphHandles, <NONE>,  'FONTOBJ_cGetAllGlyphHandles',  \
    FONTOBJ_cGetGlyphs, <NONE>,  'FONTOBJ_cGetGlyphs',  \
    FONTOBJ_pQueryGlyphAttrs, <NONE>,  'FONTOBJ_pQueryGlyphAttrs',  \
    FONTOBJ_pfdg, <NONE>,  'FONTOBJ_pfdg',  \
    FONTOBJ_pifi, <NONE>,  'FONTOBJ_pifi',  \
    FONTOBJ_pvTrueTypeFontFile, <NONE>,  'FONTOBJ_pvTrueTypeFontFile',  \
    FONTOBJ_pxoGetXform, <NONE>,  'FONTOBJ_pxoGetXform',  \
    FONTOBJ_vGetInfo, <NONE>,  'FONTOBJ_vGetInfo',  \
    FillPath, <.hdc>,  'FillPath',  \
    FillRgn, <.hdc, .hRgn, .hBrush>,  'FillRgn',  \
    FixBrushOrgEx, <.hDC, .n1, .n2, .lpPoint>,  'FixBrushOrgEx',  \
    FlattenPath, <.hdc>,  'FlattenPath',  \
    FloodFill, <.hdc, .x, .y, .crColor>,  'FloodFill',  \
    FontIsLinked, <NONE>,  'FontIsLinked',  \
    FrameRgn, <.hdc, .hRgn, .hBrush, .nWidth, .nHeight>,  'FrameRgn',  \
    GdiAddFontResourceW, <NONE>,  'GdiAddFontResourceW',  \
    GdiAddGlsBounds, <NONE>,  'GdiAddGlsBounds',  \
    GdiAddGlsRecord, <NONE>,  'GdiAddGlsRecord',  \
    GdiAlphaBlend, <NONE>,  'GdiAlphaBlend',  \
    GdiArtificialDecrementDriver, <NONE>,  'GdiArtificialDecrementDriver',  \
    GdiCleanCacheDC, <NONE>,  'GdiCleanCacheDC',  \
    GdiComment, <.hdc, .cbSize, .lpData>,  'GdiComment',  \
    GdiConsoleTextOut, <NONE>,  'GdiConsoleTextOut',  \
    GdiConvertAndCheckDC, <NONE>,  'GdiConvertAndCheckDC',  \
    GdiConvertBitmap, <NONE>,  'GdiConvertBitmap',  \
    GdiConvertBitmapV5, <NONE>,  'GdiConvertBitmapV5',  \
    GdiConvertBrush, <NONE>,  'GdiConvertBrush',  \
    GdiConvertDC, <NONE>,  'GdiConvertDC',  \
    GdiConvertEnhMetaFile, <NONE>,  'GdiConvertEnhMetaFile',  \
    GdiConvertFont, <NONE>,  'GdiConvertFont',  \
    GdiConvertMetaFilePict, <NONE>,  'GdiConvertMetaFilePict',  \
    GdiConvertPalette, <NONE>,  'GdiConvertPalette',  \
    GdiConvertRegion, <NONE>,  'GdiConvertRegion',  \
    GdiConvertToDevmodeW, <NONE>,  'GdiConvertToDevmodeW',  \
    GdiCreateLocalEnhMetaFile, <NONE>,  'GdiCreateLocalEnhMetaFile',  \
    GdiCreateLocalMetaFilePict, <NONE>,  'GdiCreateLocalMetaFilePict',  \
    GdiDeleteLocalDC, <NONE>,  'GdiDeleteLocalDC',  \
    GdiDeleteSpoolFileHandle, <NONE>,  'GdiDeleteSpoolFileHandle',  \
    GdiDescribePixelFormat, <NONE>,  'GdiDescribePixelFormat',  \
    GdiDllInitialize, <NONE>,  'GdiDllInitialize',  \
    GdiDrawStream, <NONE>,  'GdiDrawStream',  \
    GdiEndDocEMF, <NONE>,  'GdiEndDocEMF',  \
    GdiEndPageEMF, <NONE>,  'GdiEndPageEMF',  \
    GdiEntry1, <NONE>,  'GdiEntry1',  \
    GdiEntry10, <NONE>,  'GdiEntry10',  \
    GdiEntry11, <NONE>,  'GdiEntry11',  \
    GdiEntry12, <NONE>,  'GdiEntry12',  \
    GdiEntry13, <NONE>,  'GdiEntry13',  \
    GdiEntry14, <NONE>,  'GdiEntry14',  \
    GdiEntry15, <NONE>,  'GdiEntry15',  \
    GdiEntry16, <NONE>,  'GdiEntry16',  \
    GdiEntry2, <NONE>,  'GdiEntry2',  \
    GdiEntry3, <NONE>,  'GdiEntry3',  \
    GdiEntry4, <NONE>,  'GdiEntry4',  \
    GdiEntry5, <NONE>,  'GdiEntry5',  \
    GdiEntry6, <NONE>,  'GdiEntry6',  \
    GdiEntry7, <NONE>,  'GdiEntry7',  \
    GdiEntry8, <NONE>,  'GdiEntry8',  \
    GdiEntry9, <NONE>,  'GdiEntry9',  \
    GdiFixUpHandle, <NONE>,  'GdiFixUpHandle',  \
    GdiFlush, <VOID>,  'GdiFlush',  \
    GdiFullscreenControl, <NONE>,  'GdiFullscreenControl',  \
    GdiGetBatchLimit, <VOID>,  'GdiGetBatchLimit',  \
    GdiGetBitmapBitsSize, <NONE>,  'GdiGetBitmapBitsSize',  \
    GdiGetCharDimensions, <NONE>,  'GdiGetCharDimensions',  \
    GdiGetCodePage, <NONE>,  'GdiGetCodePage',  \
    GdiGetDC, <NONE>,  'GdiGetDC',  \
    GdiGetDevmodeForPage, <NONE>,  'GdiGetDevmodeForPage',  \
    GdiGetLocalBrush, <NONE>,  'GdiGetLocalBrush',  \
    GdiGetLocalDC, <NONE>,  'GdiGetLocalDC',  \
    GdiGetLocalFont, <NONE>,  'GdiGetLocalFont',  \
    GdiGetPageCount, <NONE>,  'GdiGetPageCount',  \
    GdiGetPageHandle, <NONE>,  'GdiGetPageHandle',  \
    GdiGetSpoolFileHandle, <NONE>,  'GdiGetSpoolFileHandle',  \
    GdiGetSpoolMessage, <NONE>,  'GdiGetSpoolMessage',  \
    GdiGradientFill, <NONE>,  'GdiGradientFill',  \
    GdiInitSpool, <NONE>,  'GdiInitSpool',  \
    GdiInitializeLanguagePack, <NONE>,  'GdiInitializeLanguagePack',  \
    GdiIsMetaFileDC, <NONE>,  'GdiIsMetaFileDC',  \
    GdiIsMetaPrintDC, <NONE>,  'GdiIsMetaPrintDC',  \
    GdiIsPlayMetafileDC, <NONE>,  'GdiIsPlayMetafileDC',  \
    GdiPlayDCScript, <NONE>,  'GdiPlayDCScript',  \
    GdiPlayEMF, <NONE>,  'GdiPlayEMF',  \
    GdiPlayJournal, <NONE>,  'GdiPlayJournal',  \
    GdiPlayPageEMF, <NONE>,  'GdiPlayPageEMF',  \
    GdiPlayPrivatePageEMF, <NONE>,  'GdiPlayPrivatePageEMF',  \
    GdiPlayScript, <NONE>,  'GdiPlayScript',  \
    GdiPrinterThunk, <NONE>,  'GdiPrinterThunk',  \
    GdiProcessSetup, <NONE>,  'GdiProcessSetup',  \
    GdiQueryFonts, <NONE>,  'GdiQueryFonts',  \
    GdiQueryTable, <NONE>,  'GdiQueryTable',  \
    GdiRealizationInfo, <NONE>,  'GdiRealizationInfo',  \
    GdiReleaseDC, <NONE>,  'GdiReleaseDC',  \
    GdiReleaseLocalDC, <NONE>,  'GdiReleaseLocalDC',  \
    GdiResetDCEMF, <NONE>,  'GdiResetDCEMF',  \
    GdiSetAttrs, <NONE>,  'GdiSetAttrs',  \
    GdiSetBatchLimit, <.dwLimit>,  'GdiSetBatchLimit',  \
    GdiSetLastError, <NONE>,  'GdiSetLastError',  \
    GdiSetPixelFormat, <NONE>,  'GdiSetPixelFormat',  \
    GdiSetServerAttr, <NONE>,  'GdiSetServerAttr',  \
    GdiStartDocEMF, <NONE>,  'GdiStartDocEMF',  \
    GdiStartPageEMF, <NONE>,  'GdiStartPageEMF',  \
    GdiSwapBuffers, <NONE>,  'GdiSwapBuffers',  \
    GdiTransparentBlt, <NONE>,  'GdiTransparentBlt',  \
    GdiValidateHandle, <NONE>,  'GdiValidateHandle',  \
    GetArcDirection, <.hdc>,  'GetArcDirection',  \
    GetAspectRatioFilterEx, <.hdc, .lpAspectRatio>,  'GetAspectRatioFilterEx',  \
    GetBitmapAttributes, <NONE>,  'GetBitmapAttributes',  \
    GetBitmapBits, <.hBitmap, .dwCount, .lpBits>,  'GetBitmapBits',  \
    GetBitmapDimensionEx, <.hBitmap, .lpDimension>,  'GetBitmapDimensionEx',  \
    GetBkColor, <.hdc>,  'GetBkColor',  \
    GetBkMode, <.hdc>,  'GetBkMode',  \
    GetBoundsRect, <.hdc, .lprcBounds, .flags>,  'GetBoundsRect',  \
    GetBrushAttributes, <NONE>,  'GetBrushAttributes',  \
    GetBrushOrgEx, <.hDC, .lpPoint>,  'GetBrushOrgEx',  \
    GetCharABCWidthsA, <.hdc, .uFirstChar, .uLastChar, .lpabc>,  'GetCharABCWidthsA',  \
    GetCharABCWidthsFloatA, <.hdc, .iFirstChar, .iLastChar, .lpABCF>,  'GetCharABCWidthsFloatA',  \
    GetCharABCWidthsFloatW, <.hdc, .iFirstChar, .iLastChar, .lpABCF>,  'GetCharABCWidthsFloatW',  \
    GetCharABCWidthsI, <.hdc, .uint, .lpword, .lpabc>,  'GetCharABCWidthsI',  \
    GetCharABCWidthsW, <.hdc, .uFirstChar, .uLastChar, .lpabc>,  'GetCharABCWidthsW',  \
    GetCharWidth32A, <.hdc, .iFirstChar, .iLastChar, .lpBuffer>,  'GetCharWidth32A',  \
    GetCharWidth32W, <.hdc, .iFirstChar, .iLastChar, .lpBuffer>,  'GetCharWidth32W',  \
    GetCharWidthA, <.hdc, .wFirstChar, .wLastChar, .lpBuffer>,  'GetCharWidthA',  \
    GetCharWidthFloatA, <.hdc, .iFirstChar, .iLastChar, .pxBuffer>,  'GetCharWidthFloatA',  \
    GetCharWidthFloatW, <.hdc, .iFirstChar, .iLastChar, .pxBuffer>,  'GetCharWidthFloatW',  \
    GetCharWidthI, <.hdc, .uint, .lpword, .lpint>,  'GetCharWidthI',  \
    GetCharWidthInfo, <NONE>,  'GetCharWidthInfo',  \
    GetCharWidthW, <.hdc, .wFirstChar, .wLastChar, .lpBuffer>,  'GetCharWidthW',  \
    GetCharacterPlacementA, <.hdc, .lpsz, .n1, .n2, .lpGcpResults, .dw>,  'GetCharacterPlacementA',  \
    GetCharacterPlacementW, <.hdc, .lpsz, .n1, .n2, .lpGcpResults, .dw>,  'GetCharacterPlacementW',  \
    GetClipBox, <.hdc, .lpRect>,  'GetClipBox',  \
    GetClipRgn, <.hdc, .hRgn>,  'GetClipRgn',  \
    GetColorAdjustment, <.hdc, .lpca>,  'GetColorAdjustment',  \
    GetColorSpace, <.hdc>,  'GetColorSpace',  \
    GetCurrentObject, <.hdc, .uObjectType>,  'GetCurrentObject',  \
    GetCurrentPositionEx, <.hdc, .lpPoint>,  'GetCurrentPositionEx',  \
    GetDCBrushColor, <.hdc>,  'GetDCBrushColor',  \
    GetDCOrgEx, <.hdc, .lpPoint>,  'GetDCOrgEx',  \
    GetDCPenColor, <.hdc>,  'GetDCPenColor',  \
    GetDIBColorTable, <.hDC, .un1, .un2, .pRGBQuad>,  'GetDIBColorTable',  \
    GetDIBits, <.aHDC, .hBitmap, .nStartScan, .nNumScans, .lpBits, .lpBI, .wUsage>,  'GetDIBits',  \
    GetDeviceCaps, <.hdc, .nIndex>,  'GetDeviceCaps',  \
    GetDeviceGammaRamp, <.hdc, .lpv>,  'GetDeviceGammaRamp',  \
    GetETM, <NONE>,  'GetETM',  \
    GetEUDCTimeStamp, <NONE>,  'GetEUDCTimeStamp',  \
    GetEUDCTimeStampExW, <NONE>,  'GetEUDCTimeStampExW',  \
    GetEnhMetaFileA, <.lpszMetaFile>,  'GetEnhMetaFileA',  \
    GetEnhMetaFileBits, <.hemf, .cbBuffer, .lpbBuffer>,  'GetEnhMetaFileBits',  \
    GetEnhMetaFileDescriptionA, <.hemf, .cchBuffer, .lpszDescription>,  'GetEnhMetaFileDescriptionA',  \
    GetEnhMetaFileDescriptionW, <.hemf, .cchBuffer, .lpszDescription>,  'GetEnhMetaFileDescriptionW',  \
    GetEnhMetaFileHeader, <.hemf, .cbBuffer, .lpemh>,  'GetEnhMetaFileHeader',  \
    GetEnhMetaFilePaletteEntries, <.hemf, .cEntries, .lppe>,  'GetEnhMetaFilePaletteEntries',  \
    GetEnhMetaFilePixelFormat, <.henhmetafile, .uint, .PIXELFORMATDESCRIPTOR>,  'GetEnhMetaFilePixelFormat',  \
    GetEnhMetaFileW, <.lpszMetaFile>,  'GetEnhMetaFileW',  \
    GetFontAssocStatus, <NONE>,  'GetFontAssocStatus',  \
    GetFontData, <.hdc, .dwTable, .dwOffset, .lpvBuffer, .cbData>,  'GetFontData',  \
    GetFontLanguageInfo, <.hdc>,  'GetFontLanguageInfo',  \
    GetFontResourceInfoW, <NONE>,  'GetFontResourceInfoW',  \
    GetFontUnicodeRanges, <.hdc, .LPGLYPHSET>,  'GetFontUnicodeRanges',  \
    GetGlyphIndicesA, <.hdc, .lpcstr, .ByValt, .lpword, .dword>,  'GetGlyphIndicesA',  \
    GetGlyphIndicesW, <.hdc, .lpcstr, .ByValt, .lpword, .dword>,  'GetGlyphIndicesW',  \
    GetGlyphOutline, <.hdc, .uChar, .fuFormat, .lpgm, .cbBuffer, .lpBuffer, .lpmat2>,  'GetGlyphOutline',  \
    GetGlyphOutlineA, <.hdc, .uChar, .fuFormat, .lpgm, .cbBuffer, .lpBuffer, .lpmat2>,  'GetGlyphOutlineA',  \
    GetGlyphOutlineW, <.hdc, .uChar, .fuFormat, .lpgm, .cbBuffer, .lpBuffer, .lpmat2>,  'GetGlyphOutlineW',  \
    GetGlyphOutlineWow, <NONE>,  'GetGlyphOutlineWow',  \
    GetGraphicsMode, <.hdc>,  'GetGraphicsMode',  \
    GetHFONT, <NONE>,  'GetHFONT',  \
    GetICMProfileA, <.hdc, .dw, .lpStr>,  'GetICMProfileA',  \
    GetICMProfileW, <.hdc, .dw, .lpStr>,  'GetICMProfileW',  \
    GetKerningPairs, <.hdc, .cPairs, .lpkrnpair>,  'GetKerningPairs',  \
    GetKerningPairsA, <.hdc, .cPairs, .lpkrnpair>,  'GetKerningPairsA',  \
    GetKerningPairsW, <.hdc, .cPairs, .lpkrnpair>,  'GetKerningPairsW',  \
    GetLayout, <.hdc>,  'GetLayout',  \
    GetLogColorSpaceA, <.hcolorspace, .lplogcolorspace, .dw>,  'GetLogColorSpaceA',  \
    GetLogColorSpaceW, <.hcolorspace, .lplogcolorspace, .dw>,  'GetLogColorSpaceW',  \
    GetMapMode, <.hdc>,  'GetMapMode',  \
    GetMetaFileA, <.lpFileName>,  'GetMetaFileA',  \
    GetMetaFileBitsEx, <.hMF, .nSize, .lpvData>,  'GetMetaFileBitsEx',  \
    GetMetaFileW, <.lpFileName>,  'GetMetaFileW',  \
    GetMetaRgn, <.hdc, .hRgn>,  'GetMetaRgn',  \
    GetMiterLimit, <.hdc, .peLimit>,  'GetMiterLimit',  \
    GetNearestColor, <.hdc, .crColor>,  'GetNearestColor',  \
    GetNearestPaletteIndex, <.hPalette, .crColor>,  'GetNearestPaletteIndex',  \
    GetObjectA, <.hObject, .nCount, .lpObject>,  'GetObjectA',  \
    GetObjectType, <.hgdiobj>,  'GetObjectType',  \
    GetObjectW, <.hObject, .nCount, .lpObject>,  'GetObjectW',  \
    GetOutlineTextMetricsA, <.hdc, .cbData, .lpotm>,  'GetOutlineTextMetricsA',  \
    GetOutlineTextMetricsW, <.hdc, .cbData, .lpotm>,  'GetOutlineTextMetricsW',  \
    GetPaletteEntries, <.hPalette, .wStartIndex, .wNumEntries, .lpPaletteEntries>,  'GetPaletteEntries',  \
    GetPath, <.hdc, .lpPoint, .lpTypes, .nSize>,  'GetPath',  \
    GetPixel, <.hdc, .x, .y>,  'GetPixel',  \
    GetPixelFormat, <.hDC>,  'GetPixelFormat',  \
    GetPolyFillMode, <.hdc>,  'GetPolyFillMode',  \
    GetROP2, <.hdc>,  'GetROP2',  \
    GetRandomRgn, <.hdc, .hrgn, .ByValt>,  'GetRandomRgn',  \
    GetRasterizerCaps, <.lpraststat, .cb>,  'GetRasterizerCaps',  \
    GetRegionData, <.hRgn, .dwCount, .lpRgnData>,  'GetRegionData',  \
    GetRelAbs, <NONE>,  'GetRelAbs',  \
    GetRgnBox, <.hRgn, .lpRect>,  'GetRgnBox',  \
    GetStockObject, <.fnObject>,  'GetStockObject',  \
    GetStretchBltMode, <.hdc>,  'GetStretchBltMode',  \
    GetStringBitmapA, <NONE>,  'GetStringBitmapA',  \
    GetStringBitmapW, <NONE>,  'GetStringBitmapW',  \
    GetSystemPaletteEntries, <.hdc, .wStartIndex, .wNumEntries, .lpPaletteEntries>,  'GetSystemPaletteEntries',  \
    GetSystemPaletteUse, <.hdc>,  'GetSystemPaletteUse',  \
    GetTextAlign, <.hdc>,  'GetTextAlign',  \
    GetTextCharacterExtra, <.hdc>,  'GetTextCharacterExtra',  \
    GetTextCharset, <.hdc>,  'GetTextCharset',  \
    GetTextCharsetInfo, <.hdc, .lpSig, .dwFlags>,  'GetTextCharsetInfo',  \
    GetTextColor, <.hdc>,  'GetTextColor',  \
    GetTextExtentExPointA, <.hdc, .lpszStr, .cchString, .nMaxExtent, .lpnFit, .alpDx, .lpSize>,  'GetTextExtentExPointA',  \
    GetTextExtentExPointI, <.hdc, .lpword, .ByValt, .lpint, .lpsize>,  'GetTextExtentExPointI',  \
    GetTextExtentExPointW, <.hdc, .lpszStr, .cchString, .nMaxExtent, .lpnFit, .alpDx, .lpSize>,  'GetTextExtentExPointW',  \
    GetTextExtentExPointWPri, <NONE>,  'GetTextExtentExPointWPri',  \
    GetTextExtentPoint32A, <.hdc, .lpsz, .cbString, .lpSize>,  'GetTextExtentPoint32A',  \
    GetTextExtentPoint32W, <.hdc, .lpsz, .cbString, .lpSize>,  'GetTextExtentPoint32W',  \
    GetTextExtentPointA, <.hdc, .lpszString, .cbString, .lpSize>,  'GetTextExtentPointA',  \
    GetTextExtentPointI, <.hdc, .lpword, .ByValt, .lpsize>,  'GetTextExtentPointI',  \
    GetTextExtentPointW, <.hdc, .lpszString, .cbString, .lpSize>,  'GetTextExtentPointW',  \
    GetTextFaceA, <.hdc, .nCount, .lpFacename>,  'GetTextFaceA',  \
    GetTextFaceAliasW, <NONE>,  'GetTextFaceAliasW',  \
    GetTextFaceW, <.hdc, .nCount, .lpFacename>,  'GetTextFaceW',  \
    GetTextMetricsA, <.hdc, .lpMetrics>,  'GetTextMetricsA',  \
    GetTextMetricsW, <.hdc, .lpMetrics>,  'GetTextMetricsW',  \
    GetTransform, <NONE>,  'GetTransform',  \
    GetViewportExtEx, <.hdc, .lpSize>,  'GetViewportExtEx',  \
    GetViewportOrgEx, <.hdc, .lpPoint>,  'GetViewportOrgEx',  \
    GetWinMetaFileBits, <.hemf, .cbBuffer, .lpbBuffer, .fnMapMode, .hdcRef>,  'GetWinMetaFileBits',  \
    GetWindowExtEx, <.hdc, .lpSize>,  'GetWindowExtEx',  \
    GetWindowOrgEx, <.hdc, .lpPoint>,  'GetWindowOrgEx',  \
    GetWorldTransform, <.hdc, .lpXform>,  'GetWorldTransform',  \
    HT_Get8BPPFormatPalette, <NONE>,  'HT_Get8BPPFormatPalette',  \
    HT_Get8BPPMaskPalette, <NONE>,  'HT_Get8BPPMaskPalette',  \
    IntersectClipRect, <.hdc, .X1, .Y1, .X2, .Y2>,  'IntersectClipRect',  \
    InvertRgn, <.hdc, .hRgn>,  'InvertRgn',  \
    IsValidEnhMetaRecord, <NONE>,  'IsValidEnhMetaRecord',  \
    IsValidEnhMetaRecordOffExt, <NONE>,  'IsValidEnhMetaRecordOffExt',  \
    LPtoDP, <.hdc, .lpPoint, .nCount>,  'LPtoDP',  \
    LineDDA, <.ByValt, .pLineddaproc, .lparam>,  'LineDDA',  \
    LineTo, <.hdc, .x, .y>,  'LineTo',  \
    MaskBlt, <.hdcDest, .nXDest, .nYDest, .nWidth, .nHeight, .hdcSrc, .nXSrc, .nYSrc, .hbmMask, .xMask, .yMask, .dwRop>,  'MaskBlt',  \
    MirrorRgn, <NONE>,  'MirrorRgn',  \
    ModifyWorldTransform, <.hdc, .lpXform, .iMode>,  'ModifyWorldTransform',  \
    MoveToEx, <.hdc, .x, .y, .lpPoint>,  'MoveToEx',  \
    NamedEscape, <NONE>,  'NamedEscape',  \
    OffsetClipRgn, <.hdc, .x, .y>,  'OffsetClipRgn',  \
    OffsetRgn, <.hRgn, .x, .y>,  'OffsetRgn',  \
    OffsetViewportOrgEx, <.hdc, .nX, .nY, .lpPoint>,  'OffsetViewportOrgEx',  \
    OffsetWindowOrgEx, <.hdc, .nX, .nY, .lpPoint>,  'OffsetWindowOrgEx',  \
    PATHOBJ_bEnum, <NONE>,  'PATHOBJ_bEnum',  \
    PATHOBJ_bEnumClipLines, <NONE>,  'PATHOBJ_bEnumClipLines',  \
    PATHOBJ_vEnumStart, <NONE>,  'PATHOBJ_vEnumStart',  \
    PATHOBJ_vEnumStartClipLines, <NONE>,  'PATHOBJ_vEnumStartClipLines',  \
    PATHOBJ_vGetBounds, <NONE>,  'PATHOBJ_vGetBounds',  \
    PaintRgn, <.hdc, .hRgn>,  'PaintRgn',  \
    PatBlt, <.hdc, .x, .y, .nWidth, .nHeight, .dwRop>,  'PatBlt',  \
    PathToRegion, <.hdc>,  'PathToRegion',  \
    Pie, <.hdc, .X1, .Y1, .X2, .Y2, .X3, .Y3, .X4, .Y4>,  'Pie',  \
    PlayEnhMetaFile, <.hdc, .hemf, .lpRect>,  'PlayEnhMetaFile',  \
    PlayEnhMetaFileRecord, <.hdc, .lpHandletable, .lpEnhMetaRecord, .nHandles>,  'PlayEnhMetaFileRecord',  \
    PlayMetaFile, <.hdc, .hMF>,  'PlayMetaFile',  \
    PlayMetaFileRecord, <.hdc, .lpHandletable, .lpMetaRecord, .nHandles>,  'PlayMetaFileRecord',  \
    PlgBlt, <.hdcDest, .lpPoint, .hdcSrc, .nXSrc, .nYSrc, .nWidth, .nHeight, .hbmMask, .xMask, .yMask>,  'PlgBlt',  \
    PolyBezier, <.hdc, .lppt, .cPoints>,  'PolyBezier',  \
    PolyBezierTo, <.hdc, .lppt, .cCount>,  'PolyBezierTo',  \
    PolyDraw, <.hdc, .lppt, .lpbTypes, .cCount>,  'PolyDraw',  \
    PolyPatBlt, <NONE>,  'PolyPatBlt',  \
    PolyPolygon, <.hdc, .lpPoint, .lpPolyCounts, .nCount>,  'PolyPolygon',  \
    PolyPolyline, <.hdc, .lppt, .lpdwPolyPoints, .cCount>,  'PolyPolyline',  \
    PolyTextOutA, <.hdc, .pptxt, .cStrings>,  'PolyTextOutA',  \
    PolyTextOutW, <.hdc, .pptxt, .cStrings>,  'PolyTextOutW',  \
    Polygon, <.hdc, .lpPoint, .nCount>,  'Polygon',  \
    Polyline, <.hdc, .lpPoint, .nCount>,  'Polyline',  \
    PolylineTo, <.hdc, .lppt, .cCount>,  'PolylineTo',  \
    PtInRegion, <.hRgn, .x, .y>,  'PtInRegion',  \
    PtVisible, <.hdc, .x, .y>,  'PtVisible',  \
    QueryFontAssocStatus, <NONE>,  'QueryFontAssocStatus',  \
    RealizePalette, <.hdc>,  'RealizePalette',  \
    RectInRegion, <.hRgn, .lpRect>,  'RectInRegion',  \
    RectVisible, <.hdc, .lpRect>,  'RectVisible',  \
    Rectangle, <.hdc, .X1, .Y1, .X2, .Y2>,  'Rectangle',  \
    RemoveFontMemResourceEx, <.handle>,  'RemoveFontMemResourceEx',  \
    RemoveFontResourceA, <.lpFileName>,  'RemoveFontResourceA',  \
    RemoveFontResourceExA, <.lpcstr, .dword, .DESIGNVECTOR>,  'RemoveFontResourceExA',  \
    RemoveFontResourceExW, <.lpcstr, .dword, .DESIGNVECTOR>,  'RemoveFontResourceExW',  \
    RemoveFontResourceTracking, <NONE>,  'RemoveFontResourceTracking',  \
    RemoveFontResourceW, <.lpFileName>,  'RemoveFontResourceW',  \
    ResetDCA, <.hdc, .lpInitData>,  'ResetDCA',  \
    ResetDCW, <.hdc, .lpInitData>,  'ResetDCW',  \
    ResizePalette, <.hPalette, .nNumEntries>,  'ResizePalette',  \
    RestoreDC, <.hdc, .nSavedDC>,  'RestoreDC',  \
    RoundRect, <.hdc, .X1, .Y1, .X2, .Y2, .X3, .Y3>,  'RoundRect',  \
    STROBJ_bEnum, <NONE>,  'STROBJ_bEnum',  \
    STROBJ_bEnumPositionsOnly, <NONE>,  'STROBJ_bEnumPositionsOnly',  \
    STROBJ_bGetAdvanceWidths, <NONE>,  'STROBJ_bGetAdvanceWidths',  \
    STROBJ_dwGetCodePage, <NONE>,  'STROBJ_dwGetCodePage',  \
    STROBJ_vEnumStart, <NONE>,  'STROBJ_vEnumStart',  \
    SaveDC, <.hdc>,  'SaveDC',  \
    ScaleViewportExtEx, <.hdc, .nXnum, .nXdenom, .nYnum, .nYdenom, .lpSize>,  'ScaleViewportExtEx',  \
    ScaleWindowExtEx, <.hdc, .nXnum, .nXdenom, .nYnum, .nYdenom, .lpSize>,  'ScaleWindowExtEx',  \
    SelectBrushLocal, <NONE>,  'SelectBrushLocal',  \
    SelectClipPath, <.hdc, .iMode>,  'SelectClipPath',  \
    SelectClipRgn, <.hdc, .hRgn>,  'SelectClipRgn',  \
    SelectFontLocal, <NONE>,  'SelectFontLocal',  \
    SelectObject, <.hdc, .hObject>,  'SelectObject',  \
    SelectPalette, <.hdc, .hPalette, .bForceBackground>,  'SelectPalette',  \
    SetAbortProc, <.hDC, .lpAbortProc>,  'SetAbortProc',  \
    SetArcDirection, <.hdc, .ArcDirection>,  'SetArcDirection',  \
    SetBitmapAttributes, <NONE>,  'SetBitmapAttributes',  \
    SetBitmapBits, <.hBitmap, .dwCount, .lpBits>,  'SetBitmapBits',  \
    SetBitmapDimensionEx, <.hbm, .nX, .nY, .lpSize>,  'SetBitmapDimensionEx',  \
    SetBkColor, <.hdc, .crColor>,  'SetBkColor',  \
    SetBkMode, <.hdc, .nBkMode>,  'SetBkMode',  \
    SetBoundsRect, <.hdc, .lprcBounds, .flags>,  'SetBoundsRect',  \
    SetBrushAttributes, <NONE>,  'SetBrushAttributes',  \
    SetBrushOrgEx, <.hdc, .nXOrg, .nYOrg, .lppt>,  'SetBrushOrgEx',  \
    SetColorAdjustment, <.hdc, .lpca>,  'SetColorAdjustment',  \
    SetColorSpace, <.hdc, .hcolorspace>,  'SetColorSpace',  \
    SetDCBrushColor, <.hdc, .colorref>,  'SetDCBrushColor',  \
    SetDCPenColor, <.hdc, .colorref>,  'SetDCPenColor',  \
    SetDIBColorTable, <.hDC, .un1, .un2, .pcRGBQuad>,  'SetDIBColorTable',  \
    SetDIBits, <.hdc, .hBitmap, .nStartScan, .nNumScans, .lpBits, .lpBI, .wUsage>,  'SetDIBits',  \
    SetDIBitsToDevice, <.hdc, .x, .y, .dx, .dy, .SrcX, .SrcY, .Scan, .NumScans, .Bits, .BitsInfo, .wUsage>,  'SetDIBitsToDevice',  \
    SetDeviceGammaRamp, <.hdc, .lpv>,  'SetDeviceGammaRamp',  \
    SetEnhMetaFileBits, <.cbBuffer, .lpData>,  'SetEnhMetaFileBits',  \
    SetFontEnumeration, <NONE>,  'SetFontEnumeration',  \
    SetGraphicsMode, <.hdc, .iMode>,  'SetGraphicsMode',  \
    SetICMMode, <.hdc, .n>,  'SetICMMode',  \
    SetICMProfileA, <.hdc, .lpStr>,  'SetICMProfileA',  \
    SetICMProfileW, <.hdc, .lpStr>,  'SetICMProfileW',  \
    SetLayout, <.hdc, .dword>,  'SetLayout',  \
    SetLayoutWidth, <NONE>,  'SetLayoutWidth',  \
    SetMagicColors, <NONE>,  'SetMagicColors',  \
    SetMapMode, <.hdc, .nMapMode>,  'SetMapMode',  \
    SetMapperFlags, <.hdc, .dwFlag>,  'SetMapperFlags',  \
    SetMetaFileBitsEx, <.nSize, .lpData>,  'SetMetaFileBitsEx',  \
    SetMetaRgn, <.hdc>,  'SetMetaRgn',  \
    SetMiterLimit, <.hdc, .eNewLimit, .peOldLimit>,  'SetMiterLimit',  \
    SetPaletteEntries, <.hPalette, .wStartIndex, .wNumEntries, .lpPaletteEntries>,  'SetPaletteEntries',  \
    SetPixel, <.hdc, .x, .y, .crColor>,  'SetPixel',  \
    SetPixelFormat, <.hDC, .n, .pcPixelFormatDescriptor>,  'SetPixelFormat',  \
    SetPixelV, <.hdc, .x, .y, .crColor>,  'SetPixelV',  \
    SetPolyFillMode, <.hdc, .nPolyFillMode>,  'SetPolyFillMode',  \
    SetROP2, <.hdc, .nDrawMode>,  'SetROP2',  \
    SetRectRgn, <.hRgn, .X1, .Y1, .X2, .Y2>,  'SetRectRgn',  \
    SetRelAbs, <NONE>,  'SetRelAbs',  \
    SetStretchBltMode, <.hdc, .nStretchMode>,  'SetStretchBltMode',  \
    SetSystemPaletteUse, <.hdc, .wUsage>,  'SetSystemPaletteUse',  \
    SetTextAlign, <.hdc, .fMode>,  'SetTextAlign',  \
    SetTextCharacterExtra, <.hdc, .nCharExtra>,  'SetTextCharacterExtra',  \
    SetTextColor, <.hdc, .crColor>,  'SetTextColor',  \
    SetTextJustification, <.hdc, .nBreakExtra, .nBreakCount>,  'SetTextJustification',  \
    SetViewportExtEx, <.hdc, .nX, .nY, .lpSize>,  'SetViewportExtEx',  \
    SetViewportOrgEx, <.hdc, .nX, .nY, .lpPoint>,  'SetViewportOrgEx',  \
    SetVirtualResolution, <NONE>,  'SetVirtualResolution',  \
    SetWinMetaFileBits, <.cbBuffer, .lpbBuffer, .hdcRef, .lpmfp>,  'SetWinMetaFileBits',  \
    SetWindowExtEx, <.hdc, .nX, .nY, .lpSize>,  'SetWindowExtEx',  \
    SetWindowOrgEx, <.hdc, .nX, .nY, .lpPoint>,  'SetWindowOrgEx',  \
    SetWorldTransform, <.hdc, .lpXform>,  'SetWorldTransform',  \
    StartDocA, <.hdc, .lpdi>,  'StartDocA',  \
    StartDocW, <.hdc, .lpdi>,  'StartDocW',  \
    StartFormPage, <.hdc>,  'StartFormPage',  \
    StartPage, <.hdc>,  'StartPage',  \
    StretchBlt, <.hdc, .x, .y, .nWidth, .nHeight, .hSrcDC, .xSrc, .ySrc, .nSrcWidth, .nSrcHeight, .dwRop>,  'StretchBlt',  \
    StretchDIBits, <.hdc, .x, .y, .dx, .dy, .SrcX, .SrcY, .wSrcWidth, .wSrcHeight, .lpBits, .lpBitsInfo, .wUsage, .dwRop>,  'StretchDIBits',  \
    StrokeAndFillPath, <.hdc>,  'StrokeAndFillPath',  \
    StrokePath, <.hdc>,  'StrokePath',  \
    SwapBuffers, <.hDC>,  'SwapBuffers',  \
    TextOutA, <.hdc, .x, .y, .lpString, .nCount>,  'TextOutA',  \
    TextOutW, <.hdc, .x, .y, .lpString, .nCount>,  'TextOutW',  \
    TranslateCharsetInfo, <.lpSrc, .lpcs, .dwFlags>,  'TranslateCharsetInfo',  \
    UnloadNetworkFonts, <NONE>,  'UnloadNetworkFonts',  \
    UnrealizeObject, <.hObject>,  'UnrealizeObject',  \
    UpdateColors, <.hdc>,  'UpdateColors',  \
    UpdateICMRegKeyA, <.dword, .lpstr, .uint>,  'UpdateICMRegKeyA',  \
    UpdateICMRegKeyW, <.dword, .lpstr, .uint>,  'UpdateICMRegKeyW',  \
    WidenPath, <.hdc>,  'WidenPath',  \
    XFORMOBJ_bApplyXform, <NONE>,  'XFORMOBJ_bApplyXform',  \
    XFORMOBJ_iGetXform, <NONE>,  'XFORMOBJ_iGetXform',  \
    XLATEOBJ_cGetPalette, <NONE>,  'XLATEOBJ_cGetPalette',  \
    XLATEOBJ_hGetColorTransform, <NONE>,  'XLATEOBJ_hGetColorTransform',  \
    XLATEOBJ_iXlate, <NONE>,  'XLATEOBJ_iXlate',  \
    XLATEOBJ_piVector, <NONE>,  'XLATEOBJ_piVector',  \
    bInitSystemAndFontsDirectoriesW, <NONE>,  'bInitSystemAndFontsDirectoriesW',  \
    bMakePathNameW, <NONE>,  'bMakePathNameW',  \
    cGetTTFFromFOT, <NONE>,  'cGetTTFFromFOT',  \
    gdiPlaySpoolStream, <NONE>,  'gdiPlaySpoolStream'
