; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: ole32.dll API calls
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


import_proto ole32,  \
    BindMoniker, <.pmk, .grfOpt, .iidResult, .ppvResult>,  'BindMoniker',  \
    CLIPFORMAT_UserFree, <.pLong, .pClipformat>,  'CLIPFORMAT_UserFree',  \
    CLIPFORMAT_UserMarshal, <.pLong, .pChar, .pClipformat>,  'CLIPFORMAT_UserMarshal',  \
    CLIPFORMAT_UserSize, <.pLong, .lLong, .pClipformat>,  'CLIPFORMAT_UserSize',  \
    CLIPFORMAT_UserUnmarshal, <.pLong, .pChar, .pClipformat>,  'CLIPFORMAT_UserUnmarshal',  \
    CLSIDFromOle1Class, <NONE>,  'CLSIDFromOle1Class',  \
    CLSIDFromProgID, <.TSzProgID, .T>,  'CLSIDFromProgID',  \
    CLSIDFromProgIDEx, <.lpszProgID, .lpclsid>,  'CLSIDFromProgIDEx',  \
    CLSIDFromString, <.lpsz, .pclsid>,  'CLSIDFromString',  \
    CoAddRefServerProcess, <VOID>,  'CoAddRefServerProcess',  \
    CoAllowSetForegroundWindow, <.pUnk, .lpvReserved>,  'CoAllowSetForegroundWindow',  \
    CoBuildVersion, <VOID>,  'CoBuildVersion',  \
    CoCancelCall, <.dwThreadId, .ulTimeout>,  'CoCancelCall',  \
    CoCopyProxy, <.pProxy, .ppCopy>,  'CoCopyProxy',  \
    CoCreateFreeThreadedMarshaler, <.punkOuter, .ppunkMarshal>,  'CoCreateFreeThreadedMarshaler',  \
    CoCreateGuid, <.pguid>,  'CoCreateGuid',  \
    CoCreateInstance, <.rclsid, .pUnkOuter, .dwClsContext, .riid, .ppv>,  'CoCreateInstance',  \
    CoCreateInstanceEx, <.Clsid, .punkOuter, .dwClsCtx, .pServerInfo, .dwCount, .pResults>,  'CoCreateInstanceEx',  \
    CoCreateObjectInContext, <NONE>,  'CoCreateObjectInContext',  \
    CoDeactivateObject, <NONE>,  'CoDeactivateObject',  \
    CoDisableCallCancellation, <.pReserved>,  'CoDisableCallCancellation',  \
    CoDisconnectObject, <.pUnk, .dwReserved>,  'CoDisconnectObject',  \
    CoDosDateTimeToFileTime, <.nDosDate, .nDosTime, .lpFileTime>,  'CoDosDateTimeToFileTime',  \
    CoEnableCallCancellation, <.pReserved>,  'CoEnableCallCancellation',  \
    CoFileTimeNow, <.lpFileTime>,  'CoFileTimeNow',  \
    CoFileTimeToDosDateTime, <.lpFileTime, .lpDosDate, .lpDosTime>,  'CoFileTimeToDosDateTime',  \
    CoFreeAllLibraries, <VOID>,  'CoFreeAllLibraries',  \
    CoFreeLibrary, <.hInst>,  'CoFreeLibrary',  \
    CoFreeUnusedLibraries, <VOID>,  'CoFreeUnusedLibraries',  \
    CoFreeUnusedLibrariesEx, <NONE>,  'CoFreeUnusedLibrariesEx',  \
    CoGetApartmentID, <NONE>,  'CoGetApartmentID',  \
    CoGetCallContext, <.riid, .ppInterface>,  'CoGetCallContext',  \
    CoGetCallerTID, <NONE>,  'CoGetCallerTID',  \
    CoGetCancelObject, <.dwThreadId, .iid, .ppUnk>,  'CoGetCancelObject',  \
    CoGetClassObject, <.rclsid, .dwClsContext, .pvReserved, .riid, .ppv>,  'CoGetClassObject',  \
    CoGetClassVersion, <.pClassSpec, .pdwVersionMS, .pdwVersionLS>,  'CoGetClassVersion',  \
    CoGetComCatalog, <NONE>,  'CoGetComCatalog',  \
    CoGetContextToken, <NONE>,  'CoGetContextToken',  \
    CoGetCurrentLogicalThreadId, <NONE>,  'CoGetCurrentLogicalThreadId',  \
    CoGetCurrentProcess, <VOID>,  'CoGetCurrentProcess',  \
    CoGetDefaultContext, <NONE>,  'CoGetDefaultContext',  \
    CoGetInstanceFromFile, <.pServerInfo, .pClsid, .punkOuter, .dwClsCtx, .grfMode, .pwszName, .dwCount, .pResults>,  'CoGetInstanceFromFile',  \
    CoGetInstanceFromIStorage, <.pServerInfo, .pClsid, .punkOuter, .dwClsCtx, .pstg, .dwCount, .pResults>,  'CoGetInstanceFromIStorage',  \
    CoGetInterceptor, <NONE>,  'CoGetInterceptor',  \
    CoGetInterceptorFromTypeInfo, <NONE>,  'CoGetInterceptorFromTypeInfo',  \
    CoGetInterfaceAndReleaseStream, <.pStm, .iid, .ppv>,  'CoGetInterfaceAndReleaseStream',  \
    CoGetMalloc, <.dwMemContext, .ppMalloc>,  'CoGetMalloc',  \
    CoGetMarshalSizeMax, <.pulSize, .riid, .pUnk, .dwDestContext, .pvDestContext, .mshlflags>,  'CoGetMarshalSizeMax',  \
    CoGetObject, <.pszName, .pBindOptions, .riid, .ppv>,  'CoGetObject',  \
    CoGetObjectContext, <.riid, .ppv>,  'CoGetObjectContext',  \
    CoGetPSClsid, <.riid, .pClsid>,  'CoGetPSClsid',  \
    CoGetProcessIdentifier, <NONE>,  'CoGetProcessIdentifier',  \
    CoGetStandardMarshal, <.riid, .pUnk, .dwDestContext, .pvDestContext, .mshlflags, .ppMarshal>,  'CoGetStandardMarshal',  \
    CoGetState, <NONE>,  'CoGetState',  \
    CoGetStdMarshalEx, <.pUnkOuter, .smexflags, .ppUnkInner>,  'CoGetStdMarshalEx',  \
    CoGetSystemSecurityPermissions, <NONE>,  'CoGetSystemSecurityPermissions',  \
    CoGetTreatAsClass, <.clsidOld, .pClsidNew>,  'CoGetTreatAsClass',  \
    CoImpersonateClient, <VOID>,  'CoImpersonateClient',  \
    CoInitialize, <.pzReserved>,  'CoInitialize',  \
    CoInitializeEx, <.pvReserved, .dwCoInit>,  'CoInitializeEx',  \
    CoInitializeSecurity, <.pSecDesc, .cAuthSvc, .asAuthSvc, .pReserved1, .dwAuthnLevel, .dwImpLevel, .pAuthList, .dwCapabilities,  \
        .pReserved3>,  'CoInitializeSecurity',  \
    CoInitializeWOW, <NONE>,  'CoInitializeWOW',  \
    CoInstall, <.pbc, .dwFlags, .pClassSpec, .pQuery, .pszCodeBase>,  'CoInstall',  \
    CoInvalidateRemoteMachineBindings, <NONE>,  'CoInvalidateRemoteMachineBindings',  \
    CoIsHandlerConnected, <.pUnk>,  'CoIsHandlerConnected',  \
    CoIsOle1Class, <.rclsid>,  'CoIsOle1Class',  \
    CoLoadLibrary, <.lpszLibName, .bAutoFree>,  'CoLoadLibrary',  \
    CoLockObjectExternal, <.pUnk, .fLock, .fLastUnlockReleases>,  'CoLockObjectExternal',  \
    CoMarshalHresult, <.pstm, .hresult>,  'CoMarshalHresult',  \
    CoMarshalInterThreadInterfaceInStream, <.riid, .pUnk, .ppStm>,  'CoMarshalInterThreadInterfaceInStream',  \
    CoMarshalInterface, <.pStm, .riid, .pUnk, .dwDestContext, .pvDestContext, .mshlflags>,  'CoMarshalInterface',  \
    CoPopServiceDomain, <NONE>,  'CoPopServiceDomain',  \
    CoPushServiceDomain, <NONE>,  'CoPushServiceDomain',  \
    CoQueryAuthenticationServices, <.pcAuthSvc, .asAuthSvc>,  'CoQueryAuthenticationServices',  \
    CoQueryClientBlanket, <.pAuthnSvc, .pAuthzSvc, .pServerPrincName, .pAuthnLevel, .pImpLevel, .pPrivs, .pCapabilities>,  'CoQueryClientBlanket',  \
    CoQueryProxyBlanket, <.pProxy, .pwAuthnSvc, .pAuthzSvc, .pServerPrincName, .pAuthnLevel, .pImpLevel, .pAuthInfo, .pCapabilites,  \
      >,  'CoQueryProxyBlanket',  \
    CoQueryReleaseObject, <NONE>,  'CoQueryReleaseObject',  \
    CoReactivateObject, <NONE>,  'CoReactivateObject',  \
    CoRegisterChannelHook, <.ExtensionUuid, .pChannelHook>,  'CoRegisterChannelHook',  \
    CoRegisterClassObject, <.rclsid, .pUnk, .dwClsContext, .flags, .lpdwRegister>,  'CoRegisterClassObject',  \
    CoRegisterInitializeSpy, <NONE>,  'CoRegisterInitializeSpy',  \
    CoRegisterMallocSpy, <.pMallocSpy>,  'CoRegisterMallocSpy',  \
    CoRegisterMessageFilter, <.lpMessageFilter, .lplpMessageFilter>,  'CoRegisterMessageFilter',  \
    CoRegisterPSClsid, <.riid, .rclsid>,  'CoRegisterPSClsid',  \
    CoRegisterSurrogate, <.pSurrogate>,  'CoRegisterSurrogate',  \
    CoRegisterSurrogateEx, <NONE>,  'CoRegisterSurrogateEx',  \
    CoReleaseMarshalData, <.pStm>,  'CoReleaseMarshalData',  \
    CoReleaseServerProcess, <VOID>,  'CoReleaseServerProcess',  \
    CoResumeClassObjects, <VOID>,  'CoResumeClassObjects',  \
    CoRetireServer, <NONE>,  'CoRetireServer',  \
    CoRevertToSelf, <VOID>,  'CoRevertToSelf',  \
    CoRevokeClassObject, <.dwRegister>,  'CoRevokeClassObject',  \
    CoRevokeInitializeSpy, <NONE>,  'CoRevokeInitializeSpy',  \
    CoRevokeMallocSpy, <VOID>,  'CoRevokeMallocSpy',  \
    CoSetCancelObject, <.pUnk>,  'CoSetCancelObject',  \
    CoSetProxyBlanket, <.pProxy, .dwAuthnSvc, .dwAuthzSvc, .pServerPrincName, .dwAuthnLevel, .dwImpLevel, .pAuthInfo, .dwCapabilities,  \
      >,  'CoSetProxyBlanket',  \
    CoSetState, <NONE>,  'CoSetState',  \
    CoSuspendClassObjects, <VOID>,  'CoSuspendClassObjects',  \
    CoSwitchCallContext, <.pNewObject, .ppOldObject>,  'CoSwitchCallContext',  \
    CoTaskMemAlloc, <.cb>,  'CoTaskMemAlloc',  \
    CoTaskMemFree, <.lpIDList>,  'CoTaskMemFree',  \
    CoTaskMemRealloc, <.pv, .cb>,  'CoTaskMemRealloc',  \
    CoTestCancel, <VOID>,  'CoTestCancel',  \
    CoTreatAsClass, <.clsidOld, .clsidNew>,  'CoTreatAsClass',  \
    CoUninitialize, <VOID>,  'CoUninitialize',  \
    CoUnloadingWOW, <NONE>,  'CoUnloadingWOW',  \
    CoUnmarshalHresult, <.pstm, .phresult>,  'CoUnmarshalHresult',  \
    CoUnmarshalInterface, <.pStm, .riid, .ppv>,  'CoUnmarshalInterface',  \
    CoWaitForMultipleHandles, <.dwFlags, .dwTimeout, .cHandles, .pHandles, .lpdwindex>,  'CoWaitForMultipleHandles',  \
    ComPs_CStdStubBuffer_AddRef, <NONE>,  'ComPs_CStdStubBuffer_AddRef',  \
    ComPs_CStdStubBuffer_Connect, <NONE>,  'ComPs_CStdStubBuffer_Connect',  \
    ComPs_CStdStubBuffer_CountRefs, <NONE>,  'ComPs_CStdStubBuffer_CountRefs',  \
    ComPs_CStdStubBuffer_DebugServerQueryInterface, <NONE>,  'ComPs_CStdStubBuffer_DebugServerQueryInterface',  \
    ComPs_CStdStubBuffer_DebugServerRelease, <NONE>,  'ComPs_CStdStubBuffer_DebugServerRelease',  \
    ComPs_CStdStubBuffer_Disconnect, <NONE>,  'ComPs_CStdStubBuffer_Disconnect',  \
    ComPs_CStdStubBuffer_Invoke, <NONE>,  'ComPs_CStdStubBuffer_Invoke',  \
    ComPs_CStdStubBuffer_IsIIDSupported, <NONE>,  'ComPs_CStdStubBuffer_IsIIDSupported',  \
    ComPs_CStdStubBuffer_QueryInterface, <NONE>,  'ComPs_CStdStubBuffer_QueryInterface',  \
    ComPs_IUnknown_AddRef_Proxy, <NONE>,  'ComPs_IUnknown_AddRef_Proxy',  \
    ComPs_IUnknown_QueryInterface_Proxy, <NONE>,  'ComPs_IUnknown_QueryInterface_Proxy',  \
    ComPs_IUnknown_Release_Proxy, <NONE>,  'ComPs_IUnknown_Release_Proxy',  \
    ComPs_NdrCStdStubBuffer2_Release, <NONE>,  'ComPs_NdrCStdStubBuffer2_Release',  \
    ComPs_NdrCStdStubBuffer_Release, <NONE>,  'ComPs_NdrCStdStubBuffer_Release',  \
    ComPs_NdrClientCall2, <NONE>,  'ComPs_NdrClientCall2',  \
    ComPs_NdrClientCall2_va, <NONE>,  'ComPs_NdrClientCall2_va',  \
    ComPs_NdrDllCanUnloadNow, <NONE>,  'ComPs_NdrDllCanUnloadNow',  \
    ComPs_NdrDllGetClassObject, <NONE>,  'ComPs_NdrDllGetClassObject',  \
    ComPs_NdrDllRegisterProxy, <NONE>,  'ComPs_NdrDllRegisterProxy',  \
    ComPs_NdrDllUnregisterProxy, <NONE>,  'ComPs_NdrDllUnregisterProxy',  \
    ComPs_NdrStubCall2, <NONE>,  'ComPs_NdrStubCall2',  \
    ComPs_NdrStubForwardingFunction, <NONE>,  'ComPs_NdrStubForwardingFunction',  \
    CreateAntiMoniker, <.ppmk>,  'CreateAntiMoniker',  \
    CreateBindCtx, <.reserved, .ppbc>,  'CreateBindCtx',  \
    CreateClassMoniker, <.rclsid, .ppmk>,  'CreateClassMoniker',  \
    CreateDataAdviseHolder, <.ppDAHolder>,  'CreateDataAdviseHolder',  \
    CreateDataCache, <.pUnkOuter, .rclsid, .iid, .ppv>,  'CreateDataCache',  \
    CreateErrorInfo, <.pperrinfo>,  'CreateErrorInfo',  \
    CreateFileMoniker, <.lpszPathName, .ppmk>,  'CreateFileMoniker',  \
    CreateGenericComposite, <.pmkFirst, .pmkRest, .ppmkComposite>,  'CreateGenericComposite',  \
    CreateILockBytesOnHGlobal, <.hGlobal, .fDeleteOnRelease, .pplkbyt>,  'CreateILockBytesOnHGlobal',  \
    CreateItemMoniker, <.lpszDelim, .lpszItem, .ppmk>,  'CreateItemMoniker',  \
    CreateObjrefMoniker, <.punk, .ppmk>,  'CreateObjrefMoniker',  \
    CreateOleAdviseHolder, <.ppOAHolder>,  'CreateOleAdviseHolder',  \
    CreatePointerMoniker, <.punk, .ppmk>,  'CreatePointerMoniker',  \
    CreateStdProgressIndicator, <.hwndParent, .pszTitle, .pIbscCaller, .ppIbsc>,  'CreateStdProgressIndicator',  \
    CreateStreamOnHGlobal, <.hGlobal, .fDeleteOnRelease, .ppstm>,  'CreateStreamOnHGlobal',  \
    DcomChannelSetHResult, <NONE>,  'DcomChannelSetHResult',  \
    DoDragDrop, <.pDataObj, .pDropSource, .dwOKEffects, .pdwEffect>,  'DoDragDrop',  \
    EnableHookObject, <NONE>,  'EnableHookObject',  \
    FmtIdToPropStgName, <.pfmtid, .oszName>,  'FmtIdToPropStgName',  \
    FreePropVariantArray, <.cVariants, .rgvars>,  'FreePropVariantArray',  \
    GetClassFile, <.szFilename, .pclsid>,  'GetClassFile',  \
    GetConvertStg, <.pStg>,  'GetConvertStg',  \
    GetDocumentBitStg, <NONE>,  'GetDocumentBitStg',  \
    GetErrorInfo, <.dwReserved, .pperrinfo>,  'GetErrorInfo',  \
    GetHGlobalFromILockBytes, <.plkbyt, .phglobal>,  'GetHGlobalFromILockBytes',  \
    GetHGlobalFromStream, <.pstm, .phglobal>,  'GetHGlobalFromStream',  \
    GetHookInterface, <NONE>,  'GetHookInterface',  \
    GetRunningObjectTable, <.reserved, .pprot>,  'GetRunningObjectTable',  \
    HACCEL_UserFree, <.pLong, .pHaccel>,  'HACCEL_UserFree',  \
    HACCEL_UserMarshal, <.pLong, .pChar, .pHaccel>,  'HACCEL_UserMarshal',  \
    HACCEL_UserSize, <.pLong, .lLong, .pHaccel>,  'HACCEL_UserSize',  \
    HACCEL_UserUnmarshal, <.pLong, .pChar, .pHaccel>,  'HACCEL_UserUnmarshal',  \
    HBITMAP_UserFree, <.pLong, .pHbitmap>,  'HBITMAP_UserFree',  \
    HBITMAP_UserMarshal, <.pLong, .pChar, .pHbitmap>,  'HBITMAP_UserMarshal',  \
    HBITMAP_UserSize, <.pLong, .lLong, .pHbitmap>,  'HBITMAP_UserSize',  \
    HBITMAP_UserUnmarshal, <.pLong, .pChar, .pHbitmap>,  'HBITMAP_UserUnmarshal',  \
    HBRUSH_UserFree, <NONE>,  'HBRUSH_UserFree',  \
    HBRUSH_UserMarshal, <NONE>,  'HBRUSH_UserMarshal',  \
    HBRUSH_UserSize, <NONE>,  'HBRUSH_UserSize',  \
    HBRUSH_UserUnmarshal, <NONE>,  'HBRUSH_UserUnmarshal',  \
    HDC_UserFree, <.pLong, .pHdc>,  'HDC_UserFree',  \
    HDC_UserMarshal, <.pLong, .pChar, .pHdc>,  'HDC_UserMarshal',  \
    HDC_UserSize, <.pLong, .lLong, .pHdc>,  'HDC_UserSize',  \
    HDC_UserUnmarshal, <.pLong, .pChar, .pHdc>,  'HDC_UserUnmarshal',  \
    HENHMETAFILE_UserFree, <NONE>,  'HENHMETAFILE_UserFree',  \
    HENHMETAFILE_UserMarshal, <NONE>,  'HENHMETAFILE_UserMarshal',  \
    HENHMETAFILE_UserSize, <NONE>,  'HENHMETAFILE_UserSize',  \
    HENHMETAFILE_UserUnmarshal, <NONE>,  'HENHMETAFILE_UserUnmarshal',  \
    HGLOBAL_UserFree, <.pLong, .pHglobal>,  'HGLOBAL_UserFree',  \
    HGLOBAL_UserMarshal, <.pLong, .pChar, .pHglobal>,  'HGLOBAL_UserMarshal',  \
    HGLOBAL_UserSize, <.pLong, .lLong, .pHglobal>,  'HGLOBAL_UserSize',  \
    HGLOBAL_UserUnmarshal, <.pLong, .pChar, .pHglobal>,  'HGLOBAL_UserUnmarshal',  \
    HICON_UserFree, <.pLong, .pHicon>,  'HICON_UserFree',  \
    HICON_UserMarshal, <.pLong, .pChar, .pHicon>,  'HICON_UserMarshal',  \
    HICON_UserSize, <.pLong, .llong, .pHicon>,  'HICON_UserSize',  \
    HICON_UserUnmarshal, <.pLong, .pChar, .pHicon>,  'HICON_UserUnmarshal',  \
    HMENU_UserFree, <.pLong, .pHmenu>,  'HMENU_UserFree',  \
    HMENU_UserMarshal, <.pLong, .pChar, .pHmenu>,  'HMENU_UserMarshal',  \
    HMENU_UserSize, <.pLong, .lLong, .pHmenu>,  'HMENU_UserSize',  \
    HMENU_UserUnmarshal, <.pLong, .pChar, .pHmenu>,  'HMENU_UserUnmarshal',  \
    HMETAFILEPICT_UserFree, <NONE>,  'HMETAFILEPICT_UserFree',  \
    HMETAFILEPICT_UserMarshal, <NONE>,  'HMETAFILEPICT_UserMarshal',  \
    HMETAFILEPICT_UserSize, <NONE>,  'HMETAFILEPICT_UserSize',  \
    HMETAFILEPICT_UserUnmarshal, <NONE>,  'HMETAFILEPICT_UserUnmarshal',  \
    HMETAFILE_UserFree, <NONE>,  'HMETAFILE_UserFree',  \
    HMETAFILE_UserMarshal, <NONE>,  'HMETAFILE_UserMarshal',  \
    HMETAFILE_UserSize, <NONE>,  'HMETAFILE_UserSize',  \
    HMETAFILE_UserUnmarshal, <NONE>,  'HMETAFILE_UserUnmarshal',  \
    HPALETTE_UserFree, <.pLong, .pHpalette>,  'HPALETTE_UserFree',  \
    HPALETTE_UserMarshal, <.pLong, .pChar, .pHpalette>,  'HPALETTE_UserMarshal',  \
    HPALETTE_UserSize, <.pLong, .lLong, .pHpalette>,  'HPALETTE_UserSize',  \
    HPALETTE_UserUnmarshal, <.pLong, .pChar, .pHpalette>,  'HPALETTE_UserUnmarshal',  \
    HWND_UserFree, <.pLong, .pHwnd>,  'HWND_UserFree',  \
    HWND_UserMarshal, <.pLong, .pChar, .pHwnd>,  'HWND_UserMarshal',  \
    HWND_UserSize, <.pLong, .lLong, .pHwnd>,  'HWND_UserSize',  \
    HWND_UserUnmarshal, <.pLong, .pChar, .pHwnd>,  'HWND_UserUnmarshal',  \
    HkOleRegisterObject, <NONE>,  'HkOleRegisterObject',  \
    IIDFromString, <.lpsz, .lpiid>,  'IIDFromString',  \
    IsAccelerator, <.hAccel, .cAccelEntries, .lpMsg, .lpwCmd>,  'IsAccelerator',  \
    IsEqualGUID, <NONE>,  'IsEqualGUID',  \
    IsValidIid, <NONE>,  'IsValidIid',  \
    IsValidInterface, <NONE>,  'IsValidInterface',  \
    IsValidPtrIn, <NONE>,  'IsValidPtrIn',  \
    IsValidPtrOut, <NONE>,  'IsValidPtrOut',  \
    MkParseDisplayName, <.pbc, .szUserName, .pchEaten, .ppmk>,  'MkParseDisplayName',  \
    MonikerCommonPrefixWith, <.pmkThis, .pmkOther, .ppmkCommon>,  'MonikerCommonPrefixWith',  \
    MonikerRelativePathTo, <.pmkSrc, .pmkDest, .ppmkRelPath, .dwReserved>,  'MonikerRelativePathTo',  \
    OleBuildVersion, <VOID>,  'OleBuildVersion',  \
    OleConvertIStorageToOLESTREAM, <.pstg, .lpolestream>,  'OleConvertIStorageToOLESTREAM',  \
    OleConvertIStorageToOLESTREAMEx, <.pstg, .cfFormat, .lWidth, .lHeight, .dwSize, .pmedium, .polestm>,  'OleConvertIStorageToOLESTREAMEx',  \
    OleConvertOLESTREAMToIStorage, <.lpolestream, .pstg, .ptd>,  'OleConvertOLESTREAMToIStorage',  \
    OleConvertOLESTREAMToIStorageEx, <.polestm, .pstg, .pcfFormat, .plwWidth, .plHeight, .pdwSize, .pmedium>,  'OleConvertOLESTREAMToIStorageEx',  \
    OleCreate, <.rclsid, .riid, .renderopt, .pFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreate',  \
    OleCreateDefaultHandler, <.clsid, .pUnkOuter, .riid, .lplpObj>,  'OleCreateDefaultHandler',  \
    OleCreateEmbeddingHelper, <.clsid, .pUnkOuter, .flags, .pCF, .riid, .lplpObj>,  'OleCreateEmbeddingHelper',  \
    OleCreateEx, <.rclsid, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection, .pClientSite,  \
        .pStg, .ppvObj>,  'OleCreateEx',  \
    OleCreateFromData, <.pSrcDataObj, .riid, .renderopt, .pFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateFromData',  \
    OleCreateFromDataEx, <.pSrcDataObj, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection,  \
        .pClientSite, .pStg, .ppvObj>,  'OleCreateFromDataEx',  \
    OleCreateFromFile, <.rclsid, .lpszFileName, .riid, .renderopt, .lpFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateFromFile',  \
    OleCreateFromFileEx, <.rclsid, .lpszFileName, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection,  \
        .pClientSite, .pStg, .ppvObj>,  'OleCreateFromFileEx',  \
    OleCreateLink, <.pmkLinkSrc, .riid, .renderopt, .lpFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateLink',  \
    OleCreateLinkEx, <.pmkLinkSrc, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection, .pClientSite,  \
        .pStg, .ppvObj>,  'OleCreateLinkEx',  \
    OleCreateLinkFromData, <.pSrcDataObj, .riid, .renderopt, .pFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateLinkFromData',  \
    OleCreateLinkFromDataEx, <.pSrcDataObj, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection,  \
        .pClientSite, .pStg, .ppvObj>,  'OleCreateLinkFromDataEx',  \
    OleCreateLinkToFile, <.lpszFileName, .riid, .renderopt, .lpFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateLinkToFile',  \
    OleCreateLinkToFileEx, <.lpszFileName, .riid, .dwFlags, .renderopt, .cFormats, .rgAdvf, .rgFormatEtc, .lpAdviseSink, .rgdwConnection,  \
        .pClientSite, .pStg, .ppvObj>,  'OleCreateLinkToFileEx',  \
    OleCreateMenuDescriptor, <.hmenuCombined, .lpMenuWidths>,  'OleCreateMenuDescriptor',  \
    OleCreateStaticFromData, <.pSrcDataObj, .iid, .renderopt, .pFormatEtc, .pClientSite, .pStg, .ppvObj>,  'OleCreateStaticFromData',  \
    OleDestroyMenuDescriptor, <.holemenu>,  'OleDestroyMenuDescriptor',  \
    OleDoAutoConvert, <.pStg, .pClsidNew>,  'OleDoAutoConvert',  \
    OleDraw, <.pUnknown, .dwAspect, .hdcDraw, .lprcBounds>,  'OleDraw',  \
    OleDuplicateData, <.hSrc, .cfFormat, .uiFlags>,  'OleDuplicateData',  \
    OleFlushClipboard, <VOID>,  'OleFlushClipboard',  \
    OleGetAutoConvert, <.clsidOld, .pClsidNew>,  'OleGetAutoConvert',  \
    OleGetClipboard, <.ppDataObj>,  'OleGetClipboard',  \
    OleGetIconOfClass, <.rclsid, .lpszLabel, .fUseTypeAsLabel>,  'OleGetIconOfClass',  \
    OleGetIconOfFile, <.lpszPath, .fUseFileAsLabel>,  'OleGetIconOfFile',  \
    OleInitialize, <.pvReserved>,  'OleInitialize',  \
    OleInitializeWOW, <NONE>,  'OleInitializeWOW',  \
    OleIsCurrentClipboard, <.pDataObj>,  'OleIsCurrentClipboard',  \
    OleIsRunning, <.pObject>,  'OleIsRunning',  \
    OleLoad, <.pStg, .riid, .pClientSite, .ppvObj>,  'OleLoad',  \
    OleLoadFromStream, <.pStm, .iidInterface, .ppvObj>,  'OleLoadFromStream',  \
    OleLockRunning, <.pUnknown, .fLock, .fLastUnlockCloses>,  'OleLockRunning',  \
    OleMetafilePictFromIconAndLabel, <.hIcon, .lpszLabel, .lpszSourceFile, .iIconIndex>,  'OleMetafilePictFromIconAndLabel',  \
    OleNoteObjectVisible, <.pUnknown, .fVisible>,  'OleNoteObjectVisible',  \
    OleQueryCreateFromData, <.pSrcDataObject>,  'OleQueryCreateFromData',  \
    OleQueryLinkFromData, <.pSrcDataObject>,  'OleQueryLinkFromData',  \
    OleRegEnumFormatEtc, <.clsid, .dwDirection, .ppenum>,  'OleRegEnumFormatEtc',  \
    OleRegEnumVerbs, <.clsid, .ppenum>,  'OleRegEnumVerbs',  \
    OleRegGetMiscStatus, <.clsid, .dwAspect, .pdwStatus>,  'OleRegGetMiscStatus',  \
    OleRegGetUserType, <.clsid, .dwFormOfType, .pszUserType>,  'OleRegGetUserType',  \
    OleRun, <.pUnknown>,  'OleRun',  \
    OleSave, <.pPS, .pStg, .fSameAsLoad>,  'OleSave',  \
    OleSaveToStream, <.pPStm, .pStm>,  'OleSaveToStream',  \
    OleSetAutoConvert, <.clsidOld, .clsidNew>,  'OleSetAutoConvert',  \
    OleSetClipboard, <.pDataObj>,  'OleSetClipboard',  \
    OleSetContainedObject, <.pUnknown, .fContained>,  'OleSetContainedObject',  \
    OleSetMenuDescriptor, <.holemenu, .hwndFrame, .hwndActiveObject, .lpFrame, .lpActiveObj>,  'OleSetMenuDescriptor',  \
    OleTranslateAccelerator, <.lpFrame, .lpFrameInfo, .lpmsg>,  'OleTranslateAccelerator',  \
    OleUninitialize, <VOID>,  'OleUninitialize',  \
    OpenOrCreateStream, <NONE>,  'OpenOrCreateStream',  \
    ProgIDFromCLSID, <.clsid, .lplpszProgID>,  'ProgIDFromCLSID',  \
    PropStgNameToFmtId, <.oszName, .pfmtid>,  'PropStgNameToFmtId',  \
    PropSysAllocString, <NONE>,  'PropSysAllocString',  \
    PropSysFreeString, <NONE>,  'PropSysFreeString',  \
    PropVariantChangeType, <NONE>,  'PropVariantChangeType',  \
    PropVariantClear, <.pvar>,  'PropVariantClear',  \
    PropVariantCopy, <.pvarDest, .pvarSrc>,  'PropVariantCopy',  \
    ReadClassStg, <.pStg, .pclsid>,  'ReadClassStg',  \
    ReadClassStm, <.pStm, .pclsid>,  'ReadClassStm',  \
    ReadFmtUserTypeStg, <.pstg, .pcf, .lplpszUserType>,  'ReadFmtUserTypeStg',  \
    ReadOleStg, <NONE>,  'ReadOleStg',  \
    ReadStringStream, <NONE>,  'ReadStringStream',  \
    RegisterDragDrop, <.hwnd, .pDropTarget>,  'RegisterDragDrop',  \
    ReleaseStgMedium, <.lpstgmedium>,  'ReleaseStgMedium',  \
    RevokeDragDrop, <.hwnd>,  'RevokeDragDrop',  \
    SNB_UserFree, <.pLong, .pSnb>,  'SNB_UserFree',  \
    SNB_UserMarshal, <.pLong, .pChar, .pSnb>,  'SNB_UserMarshal',  \
    SNB_UserSize, <.pLong, .lLong, .pSnb>,  'SNB_UserSize',  \
    SNB_UserUnmarshal, <.pLong, .pChar, .pSnb>,  'SNB_UserUnmarshal',  \
    STGMEDIUM_UserFree, <.pLong, .pStgmedium>,  'STGMEDIUM_UserFree',  \
    STGMEDIUM_UserMarshal, <.pLong, .pChar, .pStgmedium>,  'STGMEDIUM_UserMarshal',  \
    STGMEDIUM_UserSize, <.pLong, .long, .pStgmedium>,  'STGMEDIUM_UserSize',  \
    STGMEDIUM_UserUnmarshal, <.pLong, .pChar, .pStgmedium>,  'STGMEDIUM_UserUnmarshal',  \
    SetConvertStg, <.pStg, .fConvert>,  'SetConvertStg',  \
    SetDocumentBitStg, <NONE>,  'SetDocumentBitStg',  \
    SetErrorInfo, <.dwReserved, .perrinfo>,  'SetErrorInfo',  \
    StgConvertPropertyToVariant, <NONE>,  'StgConvertPropertyToVariant',  \
    StgConvertVariantToProperty, <NONE>,  'StgConvertVariantToProperty',  \
    StgCreateDocfile, <.pwcsName, .grfMode, .reserved, .ppstgOpen>,  'StgCreateDocfile',  \
    StgCreateDocfileOnILockBytes, <.plkbyt, .grfMode, .reserved, .ppstgOpen>,  'StgCreateDocfileOnILockBytes',  \
    StgCreatePropSetStg, <.pStorage, .dwReserved, .ppPropSetStg>,  'StgCreatePropSetStg',  \
    StgCreatePropStg, <.pUnk, .fmtid, .pclsid, .grfFlags, .dwReserved, .ppPropStg>,  'StgCreatePropStg',  \
    StgCreateStorageEx, <.pwcsName, .grfMode, .stgfmt, .grfAttrs, .pStgOptions, .reserved, .riid, .ppObjectOpen>,  'StgCreateStorageEx',  \
    StgGetIFillLockBytesOnFile, <.pwcsName, .ppflb>,  'StgGetIFillLockBytesOnFile',  \
    StgGetIFillLockBytesOnILockBytes, <.pilb, .ppflb>,  'StgGetIFillLockBytesOnILockBytes',  \
    StgIsStorageFile, <.pwcsName>,  'StgIsStorageFile',  \
    StgIsStorageILockBytes, <.plkbyt>,  'StgIsStorageILockBytes',  \
    StgOpenAsyncDocfileOnIFillLockBytes, <.pflb, .grfMode, .asyncFlags, .ppstgOpen>,  'StgOpenAsyncDocfileOnIFillLockBytes',  \
    StgOpenPropStg, <.pUnk, .fmtid, .grfFlags, .dwReserved, .ppPropStg>,  'StgOpenPropStg',  \
    StgOpenStorage, <.pwcsName, .pstgPriority, .grfMode, .snbExclude, .reserved, .ppstgOpen>,  'StgOpenStorage',  \
    StgOpenStorageEx, <.pwcsName, .grfMode, .stgfmt, .grfAttrs, .pStgOptions, .reserved, .riid, .ppObjectOpen>,  'StgOpenStorageEx',  \
    StgOpenStorageOnHandle, <NONE>,  'StgOpenStorageOnHandle',  \
    StgOpenStorageOnILockBytes, <.plkbyt, .pstgPriority, .grfMode, .snbExclude, .reserved, .ppstgOpen>,  'StgOpenStorageOnILockBytes',  \
    StgPropertyLengthAsVariant, <NONE>,  'StgPropertyLengthAsVariant',  \
    StgSetTimes, <.lpszName, .pctime, .patime, .pmtime>,  'StgSetTimes',  \
    StringFromCLSID, <.rclsid, .lplpsz>,  'StringFromCLSID',  \
    StringFromGUID2, <.rguid, .lpsz, .cchMax>,  'StringFromGUID2',  \
    StringFromIID, <.rclsid, .lplpsz>,  'StringFromIID',  \
    UpdateDCOMSettings, <NONE>,  'UpdateDCOMSettings',  \
    UtConvertDvtd16toDvtd32, <NONE>,  'UtConvertDvtd16toDvtd32',  \
    UtConvertDvtd32toDvtd16, <NONE>,  'UtConvertDvtd32toDvtd16',  \
    UtGetDvtd16Info, <NONE>,  'UtGetDvtd16Info',  \
    UtGetDvtd32Info, <NONE>,  'UtGetDvtd32Info',  \
    WdtpInterfacePointer_UserFree, <NONE>,  'WdtpInterfacePointer_UserFree',  \
    WdtpInterfacePointer_UserMarshal, <NONE>,  'WdtpInterfacePointer_UserMarshal',  \
    WdtpInterfacePointer_UserSize, <NONE>,  'WdtpInterfacePointer_UserSize',  \
    WdtpInterfacePointer_UserUnmarshal, <NONE>,  'WdtpInterfacePointer_UserUnmarshal',  \
    WriteClassStg, <.pStg, .rclsid>,  'WriteClassStg',  \
    WriteClassStm, <.pStm, .rclsid>,  'WriteClassStm',  \
    WriteFmtUserTypeStg, <.pstg, .cf, .lpszUserType>,  'WriteFmtUserTypeStg',  \
    WriteOleStg, <NONE>,  'WriteOleStg',  \
    WriteStringStream, <NONE>,  'WriteStringStream'
