; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: shell32.dll API calls
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


import_proto shell32,  \
    Activate_RunDLL, <NONE>,  'Activate_RunDLL',  \
    AppCompat_RunDLLW, <NONE>,  'AppCompat_RunDLLW',  \
    CDefFolderMenu_Create, <NONE>,  'CDefFolderMenu_Create',  \
    CDefFolderMenu_Create2, <NONE>,  'CDefFolderMenu_Create2',  \
    CallCPLEntry16, <NONE>,  'CallCPLEntry16',  \
    CheckEscapesA, <NONE>,  'CheckEscapesA',  \
    CheckEscapesW, <NONE>,  'CheckEscapesW',  \
    CommandLineToArgvW, <.lpCmdLine, .pNumArgs>,  'CommandLineToArgvW',  \
    Control_FillCache_RunDLL, <NONE>,  'Control_FillCache_RunDLL',  \
    Control_FillCache_RunDLLA, <NONE>,  'Control_FillCache_RunDLLA',  \
    Control_FillCache_RunDLLW, <NONE>,  'Control_FillCache_RunDLLW',  \
    Control_RunDLL, <NONE>,  'Control_RunDLL',  \
    Control_RunDLLA, <NONE>,  'Control_RunDLLA',  \
    Control_RunDLLAsUserW, <NONE>,  'Control_RunDLLAsUserW',  \
    Control_RunDLLW, <NONE>,  'Control_RunDLLW',  \
    DAD_AutoScroll, <NONE>,  'DAD_AutoScroll',  \
    DAD_DragEnterEx, <NONE>,  'DAD_DragEnterEx',  \
    DAD_DragEnterEx2, <NONE>,  'DAD_DragEnterEx2',  \
    DAD_DragLeave, <NONE>,  'DAD_DragLeave',  \
    DAD_DragMove, <NONE>,  'DAD_DragMove',  \
    DAD_SetDragImage, <NONE>,  'DAD_SetDragImage',  \
    DAD_ShowDragImage, <NONE>,  'DAD_ShowDragImage',  \
    DoEnvironmentSubstA, <.szString, .cbString>,  'DoEnvironmentSubstA',  \
    DoEnvironmentSubstW, <.szString, .cbString>,  'DoEnvironmentSubstW',  \
    DragAcceptFiles, <.hwnd, .fAccept>,  'DragAcceptFiles',  \
    DragFinish, <.hDrop>,  'DragFinish',  \
    DragQueryFile, <.HDROP, .UINT, .lpStr, .ch>,  'DragQueryFile',  \
    DragQueryFileA, <.HDROP, .UINT, .lpStr, .ch>,  'DragQueryFileA',  \
    DragQueryFileAorW, <NONE>,  'DragQueryFileAorW',  \
    DragQueryFileW, <.HDROP, .UINT, .lpStr, .ch>,  'DragQueryFileW',  \
    DragQueryPoint, <.HDROP, .lpPoint>,  'DragQueryPoint',  \
    DriveType, <NONE>,  'DriveType',  \
    DuplicateIcon, <.hInst, .hIcon>,  'DuplicateIcon',  \
    ExtractAssociatedIconA, <.hInst, .lpIconPath, .lpiIcon>,  'ExtractAssociatedIconA',  \
    ExtractAssociatedIconExA, <NONE>,  'ExtractAssociatedIconExA',  \
    ExtractAssociatedIconExW, <NONE>,  'ExtractAssociatedIconExW',  \
    ExtractAssociatedIconW, <.hInst, .lpIconPath, .lpiIcon>,  'ExtractAssociatedIconW',  \
    ExtractIconA, <.hInst, .lpszExeFileName, .nIconIndex>,  'ExtractIconA',  \
    ExtractIconEx, <.lpszFile, .nIconIndex, .phiconLarge, .phiconSmall, .nIcons>,  'ExtractIconEx',  \
    ExtractIconExA, <.lpszFile, .nIconIndex, .phiconLarge, .phiconSmall, .nIcons>,  'ExtractIconExA',  \
    ExtractIconExW, <.lpszFile, .nIconIndex, .phiconLarge, .phiconSmall, .nIcons>,  'ExtractIconExW',  \
    ExtractIconResInfoA, <NONE>,  'ExtractIconResInfoA',  \
    ExtractIconResInfoW, <NONE>,  'ExtractIconResInfoW',  \
    ExtractIconW, <.hInst, .lpszExeFileName, .nIconIndex>,  'ExtractIconW',  \
    ExtractVersionResource16W, <NONE>,  'ExtractVersionResource16W',  \
    FindExeDlgProc, <NONE>,  'FindExeDlgProc',  \
    FindExecutableA, <.lpFile, .lpDirectory, .lpResult>,  'FindExecutableA',  \
    FindExecutableW, <.lpFile, .lpDirectory, .lpResult>,  'FindExecutableW',  \
    FreeIconList, <NONE>,  'FreeIconList',  \
    GetFileNameFromBrowse, <NONE>,  'GetFileNameFromBrowse',  \
    ILAppendID, <NONE>,  'ILAppendID',  \
    ILClone, <NONE>,  'ILClone',  \
    ILCloneFirst, <NONE>,  'ILCloneFirst',  \
    ILCombine, <NONE>,  'ILCombine',  \
    ILCreateFromPath, <NONE>,  'ILCreateFromPath',  \
    ILCreateFromPathA, <NONE>,  'ILCreateFromPathA',  \
    ILCreateFromPathW, <NONE>,  'ILCreateFromPathW',  \
    ILFindChild, <NONE>,  'ILFindChild',  \
    ILFindLastID, <NONE>,  'ILFindLastID',  \
    ILFree, <NONE>,  'ILFree',  \
    ILGetNext, <NONE>,  'ILGetNext',  \
    ILGetSize, <NONE>,  'ILGetSize',  \
    ILIsEqual, <NONE>,  'ILIsEqual',  \
    ILIsParent, <NONE>,  'ILIsParent',  \
    ILLoadFromStream, <NONE>,  'ILLoadFromStream',  \
    ILRemoveLastID, <NONE>,  'ILRemoveLastID',  \
    ILSaveToStream, <NONE>,  'ILSaveToStream',  \
    InternalExtractIconListA, <NONE>,  'InternalExtractIconListA',  \
    InternalExtractIconListW, <NONE>,  'InternalExtractIconListW',  \
    IsLFNDrive, <NONE>,  'IsLFNDrive',  \
    IsLFNDriveA, <NONE>,  'IsLFNDriveA',  \
    IsLFNDriveW, <NONE>,  'IsLFNDriveW',  \
    IsNetDrive, <NONE>,  'IsNetDrive',  \
    IsUserAnAdmin, <NONE>,  'IsUserAnAdmin',  \
    OpenAs_RunDLL, <NONE>,  'OpenAs_RunDLL',  \
    OpenAs_RunDLLA, <NONE>,  'OpenAs_RunDLLA',  \
    OpenAs_RunDLLW, <NONE>,  'OpenAs_RunDLLW',  \
    OpenRegStream, <NONE>,  'OpenRegStream',  \
    Options_RunDLL, <NONE>,  'Options_RunDLL',  \
    Options_RunDLLA, <NONE>,  'Options_RunDLLA',  \
    Options_RunDLLW, <NONE>,  'Options_RunDLLW',  \
    PathCleanupSpec, <NONE>,  'PathCleanupSpec',  \
    PathGetShortPath, <NONE>,  'PathGetShortPath',  \
    PathIsExe, <NONE>,  'PathIsExe',  \
    PathIsSlowA, <NONE>,  'PathIsSlowA',  \
    PathIsSlowW, <NONE>,  'PathIsSlowW',  \
    PathMakeUniqueName, <NONE>,  'PathMakeUniqueName',  \
    PathProcessCommand, <NONE>,  'PathProcessCommand',  \
    PathQualify, <NONE>,  'PathQualify',  \
    PathResolve, <NONE>,  'PathResolve',  \
    PathYetAnotherMakeUniqueName, <NONE>,  'PathYetAnotherMakeUniqueName',  \
    PickIconDlg, <NONE>,  'PickIconDlg',  \
    PifMgr_CloseProperties, <NONE>,  'PifMgr_CloseProperties',  \
    PifMgr_GetProperties, <NONE>,  'PifMgr_GetProperties',  \
    PifMgr_OpenProperties, <NONE>,  'PifMgr_OpenProperties',  \
    PifMgr_SetProperties, <NONE>,  'PifMgr_SetProperties',  \
    PrintersGetCommand_RunDLL, <NONE>,  'PrintersGetCommand_RunDLL',  \
    PrintersGetCommand_RunDLLA, <NONE>,  'PrintersGetCommand_RunDLLA',  \
    PrintersGetCommand_RunDLLW, <NONE>,  'PrintersGetCommand_RunDLLW',  \
    ReadCabinetState, <NONE>,  'ReadCabinetState',  \
    RealDriveType, <NONE>,  'RealDriveType',  \
    RealShellExecuteA, <NONE>,  'RealShellExecuteA',  \
    RealShellExecuteExA, <NONE>,  'RealShellExecuteExA',  \
    RealShellExecuteExW, <NONE>,  'RealShellExecuteExW',  \
    RealShellExecuteW, <NONE>,  'RealShellExecuteW',  \
    RegenerateUserEnvironment, <NONE>,  'RegenerateUserEnvironment',  \
    RestartDialog, <NONE>,  'RestartDialog',  \
    RestartDialogEx, <NONE>,  'RestartDialogEx',  \
    SHAddFromPropSheetExtArray, <NONE>,  'SHAddFromPropSheetExtArray',  \
    SHAddToRecentDocs, <.uFlags, .pv>,  'SHAddToRecentDocs',  \
    SHAlloc, <NONE>,  'SHAlloc',  \
    SHAllocShared, <NONE>,  'SHAllocShared',  \
    SHAppBarMessage, <.dwMessage, .pData>,  'SHAppBarMessage',  \
    SHBindToParent, <.pidl, .riid, .ppv, .ppidlLast>,  'SHBindToParent',  \
    SHBrowseForFolder, <.lpbi>,  'SHBrowseForFolder',  \
    SHBrowseForFolderA, <.lpbi>,  'SHBrowseForFolderA',  \
    SHBrowseForFolderW, <.lpbi>,  'SHBrowseForFolderW',  \
    SHCLSIDFromString, <NONE>,  'SHCLSIDFromString',  \
    SHChangeNotification_Lock, <NONE>,  'SHChangeNotification_Lock',  \
    SHChangeNotification_Unlock, <NONE>,  'SHChangeNotification_Unlock',  \
    SHChangeNotify, <.wEventId, .uFlags, .dwItem1, .dwItem2>,  'SHChangeNotify',  \
    SHChangeNotifyDeregister, <NONE>,  'SHChangeNotifyDeregister',  \
    SHChangeNotifyRegister, <NONE>,  'SHChangeNotifyRegister',  \
    SHChangeNotifySuspendResume, <NONE>,  'SHChangeNotifySuspendResume',  \
    SHCloneSpecialIDList, <NONE>,  'SHCloneSpecialIDList',  \
    SHCoCreateInstance, <NONE>,  'SHCoCreateInstance',  \
    SHCreateDirectory, <NONE>,  'SHCreateDirectory',  \
    SHCreateDirectoryExA, <.hwnd, .pszPath, .psa>,  'SHCreateDirectoryExA',  \
    SHCreateDirectoryExW, <.hwnd, .pszPath, .psa>,  'SHCreateDirectoryExW',  \
    SHCreateFileExtractIconW, <NONE>,  'SHCreateFileExtractIconW',  \
    SHCreateLocalServerRunDll, <NONE>,  'SHCreateLocalServerRunDll',  \
    SHCreateProcessAsUserW, <NONE>,  'SHCreateProcessAsUserW',  \
    SHCreatePropSheetExtArray, <NONE>,  'SHCreatePropSheetExtArray',  \
    SHCreateQueryCancelAutoPlayMoniker, <NONE>,  'SHCreateQueryCancelAutoPlayMoniker',  \
    SHCreateShellFolderView, <NONE>,  'SHCreateShellFolderView',  \
    SHCreateShellFolderViewEx, <NONE>,  'SHCreateShellFolderViewEx',  \
    SHCreateShellItem, <NONE>,  'SHCreateShellItem',  \
    SHCreateStdEnumFmtEtc, <NONE>,  'SHCreateStdEnumFmtEtc',  \
    SHDefExtractIconA, <NONE>,  'SHDefExtractIconA',  \
    SHDefExtractIconW, <NONE>,  'SHDefExtractIconW',  \
    SHDestroyPropSheetExtArray, <NONE>,  'SHDestroyPropSheetExtArray',  \
    SHDoDragDrop, <NONE>,  'SHDoDragDrop',  \
    SHEmptyRecycleBinA, <.hwnd, .pszRootPath, .dwFlags>,  'SHEmptyRecycleBinA',  \
    SHEmptyRecycleBinW, <.hwnd, .pszRootPath, .dwFlags>,  'SHEmptyRecycleBinW',  \
    SHEnableServiceObject, <NONE>,  'SHEnableServiceObject',  \
    SHEnumerateUnreadMailAccountsW, <NONE>,  'SHEnumerateUnreadMailAccountsW',  \
    SHExtractIconsW, <NONE>,  'SHExtractIconsW',  \
    SHFileOperation, <.lpFileOp>,  'SHFileOperation',  \
    SHFileOperationA, <.lpFileOp>,  'SHFileOperationA',  \
    SHFileOperationW, <.lpFileOp>,  'SHFileOperationW',  \
    SHFindFiles, <NONE>,  'SHFindFiles',  \
    SHFind_InitMenuPopup, <NONE>,  'SHFind_InitMenuPopup',  \
    SHFlushClipboard, <NONE>,  'SHFlushClipboard',  \
    SHFlushSFCache, <NONE>,  'SHFlushSFCache',  \
    SHFormatDrive, <NONE>,  'SHFormatDrive',  \
    SHFree, <NONE>,  'SHFree',  \
    SHFreeNameMappings, <.hNameMappings>,  'SHFreeNameMappings',  \
    SHFreeShared, <NONE>,  'SHFreeShared',  \
    SHGetAttributesFromDataObject, <NONE>,  'SHGetAttributesFromDataObject',  \
    SHGetDataFromIDListA, <.psf, .pidl, .nFormat, .pv, .cb>,  'SHGetDataFromIDListA',  \
    SHGetDataFromIDListW, <.psf, .pidl, .nFormat, .pv, .cb>,  'SHGetDataFromIDListW',  \
    SHGetDesktopFolder, <.ppshf>,  'SHGetDesktopFolder',  \
    SHGetDiskFreeSpaceA, <NONE>,  'SHGetDiskFreeSpaceA',  \
    SHGetDiskFreeSpaceExA, <.pszDirectoryName, .pulFreeBytesAvailableToCaller, .pulTotalNumberOfBytes, .pulTotalNumberOfFreeBytes,  \
      >,  'SHGetDiskFreeSpaceExA',  \
    SHGetDiskFreeSpaceExW, <.pszDirectoryName, .pulFreeBytesAvailableToCaller, .pulTotalNumberOfBytes, .pulTotalNumberOfFreeBytes,  \
      >,  'SHGetDiskFreeSpaceExW',  \
    SHGetFileInfo, <.pszPath, .dwFileAttributes, .psfi, .cbFileInfo, .uFlags>,  'SHGetFileInfo',  \
    SHGetFileInfoA, <.pszPath, .dwFileAttributes, .psfi, .cbFileInfo, .uFlags>,  'SHGetFileInfoA',  \
    SHGetFileInfoW, <.pszPath, .dwFileAttributes, .psfi, .cbFileInfo, .uFlags>,  'SHGetFileInfoW',  \
    SHGetFolderLocation, <.hwnd, .csidl, .hToken, .dwFlags, .ppidl>,  'SHGetFolderLocation',  \
    SHGetFolderPathA, <.hwnd, .csidl, .hToken, .dwFlags, .pszPath>,  'SHGetFolderPathA',  \
    SHGetFolderPathAndSubDirA, <NONE>,  'SHGetFolderPathAndSubDirA',  \
    SHGetFolderPathAndSubDirW, <NONE>,  'SHGetFolderPathAndSubDirW',  \
    SHGetFolderPathW, <.hwnd, .csidl, .hToken, .dwFlags, .pszPath>,  'SHGetFolderPathW',  \
    SHGetIconOverlayIndexA, <.pszIconPath, .iIconIndex>,  'SHGetIconOverlayIndexA',  \
    SHGetIconOverlayIndexW, <.pszIconPath, .iIconIndex>,  'SHGetIconOverlayIndexW',  \
    SHGetImageList, <NONE>,  'SHGetImageList',  \
    SHGetInstanceExplorer, <.ppunk>,  'SHGetInstanceExplorer',  \
    SHGetMalloc, <.ppMalloc>,  'SHGetMalloc',  \
    SHGetNewLinkInfo, <.pszLinkto, .pszDir, .pszName, .pfMustCopy, .uFlags>,  'SHGetNewLinkInfo',  \
    SHGetNewLinkInfoA, <.pszLinkto, .pszDir, .pszName, .pfMustCopy, .uFlags>,  'SHGetNewLinkInfoA',  \
    SHGetNewLinkInfoW, <.pszLinkto, .pszDir, .pszName, .pfMustCopy, .uFlags>,  'SHGetNewLinkInfoW',  \
    SHGetPathFromIDList, <.pidl, .pszPath>,  'SHGetPathFromIDList',  \
    SHGetPathFromIDListA, <.pidl, .pszPath>,  'SHGetPathFromIDListA',  \
    SHGetPathFromIDListW, <.pidl, .pszPath>,  'SHGetPathFromIDListW',  \
    SHGetRealIDL, <NONE>,  'SHGetRealIDL',  \
    SHGetSetFolderCustomSettingsW, <NONE>,  'SHGetSetFolderCustomSettingsW',  \
    SHGetSetSettings, <NONE>,  'SHGetSetSettings',  \
    SHGetSettings, <.lpsfs, .dwMask>,  'SHGetSettings',  \
    SHGetShellStyleHInstance, <NONE>,  'SHGetShellStyleHInstance',  \
    SHGetSpecialFolderLocation, <.hwnd, .csidl, .ppidl>,  'SHGetSpecialFolderLocation',  \
    SHGetSpecialFolderPathA, <.hwnd, .pszPath, .csidl, .fCreate>,  'SHGetSpecialFolderPathA',  \
    SHGetSpecialFolderPathW, <.hwnd, .pszPath, .csidl, .fCreate>,  'SHGetSpecialFolderPathW',  \
    SHGetUnreadMailCountW, <NONE>,  'SHGetUnreadMailCountW',  \
    SHHandleUpdateImage, <NONE>,  'SHHandleUpdateImage',  \
    SHHelpShortcuts_RunDLL, <NONE>,  'SHHelpShortcuts_RunDLL',  \
    SHHelpShortcuts_RunDLLA, <NONE>,  'SHHelpShortcuts_RunDLLA',  \
    SHHelpShortcuts_RunDLLW, <NONE>,  'SHHelpShortcuts_RunDLLW',  \
    SHILCreateFromPath, <NONE>,  'SHILCreateFromPath',  \
    SHInvokePrinterCommandA, <.hwnd, .uAction, .lpBuf1, .lpBuf2, .fModal>,  'SHInvokePrinterCommandA',  \
    SHInvokePrinterCommandW, <.hwnd, .uAction, .lpBuf1, .lpBuf2, .fModal>,  'SHInvokePrinterCommandW',  \
    SHIsFileAvailableOffline, <.pwszPath, .pdwStatus>,  'SHIsFileAvailableOffline',  \
    SHLimitInputEdit, <NONE>,  'SHLimitInputEdit',  \
    SHLoadInProc, <.rclsid>,  'SHLoadInProc',  \
    SHLoadNonloadedIconOverlayIdentifiers, <VOID>,  'SHLoadNonloadedIconOverlayIdentifiers',  \
    SHLoadOLE, <NONE>,  'SHLoadOLE',  \
    SHLockShared, <NONE>,  'SHLockShared',  \
    SHMapIDListToImageListIndexAsync, <NONE>,  'SHMapIDListToImageListIndexAsync',  \
    SHMapPIDLToSystemImageListIndex, <NONE>,  'SHMapPIDLToSystemImageListIndex',  \
    SHMultiFileProperties, <NONE>,  'SHMultiFileProperties',  \
    SHObjectProperties, <NONE>,  'SHObjectProperties',  \
    SHOpenFolderAndSelectItems, <NONE>,  'SHOpenFolderAndSelectItems',  \
    SHOpenPropSheetW, <NONE>,  'SHOpenPropSheetW',  \
    SHParseDisplayName, <NONE>,  'SHParseDisplayName',  \
    SHPathPrepareForWriteA, <.hwnd, .punkEnableModless, .pszPath, .dwFlags>,  'SHPathPrepareForWriteA',  \
    SHPathPrepareForWriteW, <.hwnd, .punkEnableModless, .pszPath, .dwFlags>,  'SHPathPrepareForWriteW',  \
    SHPropStgCreate, <NONE>,  'SHPropStgCreate',  \
    SHPropStgReadMultiple, <NONE>,  'SHPropStgReadMultiple',  \
    SHPropStgWriteMultiple, <NONE>,  'SHPropStgWriteMultiple',  \
    SHQueryRecycleBinA, <.pszRootPath, .pSHQueryRBInfo>,  'SHQueryRecycleBinA',  \
    SHQueryRecycleBinW, <.pszRootPath, .pSHQueryRBInfo>,  'SHQueryRecycleBinW',  \
    SHReplaceFromPropSheetExtArray, <NONE>,  'SHReplaceFromPropSheetExtArray',  \
    SHRestricted, <NONE>,  'SHRestricted',  \
    SHRunControlPanel, <NONE>,  'SHRunControlPanel',  \
    SHSetInstanceExplorer, <NONE>,  'SHSetInstanceExplorer',  \
    SHSetLocalizedName, <NONE>,  'SHSetLocalizedName',  \
    SHSetUnreadMailCountW, <NONE>,  'SHSetUnreadMailCountW',  \
    SHShellFolderView_Message, <NONE>,  'SHShellFolderView_Message',  \
    SHSimpleIDListFromPath, <NONE>,  'SHSimpleIDListFromPath',  \
    SHStartNetConnectionDialogW, <NONE>,  'SHStartNetConnectionDialogW',  \
    SHTestTokenMembership, <NONE>,  'SHTestTokenMembership',  \
    SHUnlockShared, <NONE>,  'SHUnlockShared',  \
    SHUpdateImageA, <NONE>,  'SHUpdateImageA',  \
    SHUpdateImageW, <NONE>,  'SHUpdateImageW',  \
    SHUpdateRecycleBinIcon, <NONE>,  'SHUpdateRecycleBinIcon',  \
    SHValidateUNC, <NONE>,  'SHValidateUNC',  \
    SheChangeDirA, <NONE>,  'SheChangeDirA',  \
    SheChangeDirExA, <NONE>,  'SheChangeDirExA',  \
    SheChangeDirExW, <NONE>,  'SheChangeDirExW',  \
    SheChangeDirW, <NONE>,  'SheChangeDirW',  \
    SheConvertPathW, <NONE>,  'SheConvertPathW',  \
    SheFullPathA, <NONE>,  'SheFullPathA',  \
    SheFullPathW, <NONE>,  'SheFullPathW',  \
    SheGetCurDrive, <NONE>,  'SheGetCurDrive',  \
    SheGetDirA, <NONE>,  'SheGetDirA',  \
    SheGetDirExW, <NONE>,  'SheGetDirExW',  \
    SheGetDirW, <NONE>,  'SheGetDirW',  \
    SheGetPathOffsetW, <NONE>,  'SheGetPathOffsetW',  \
    SheRemoveQuotesA, <NONE>,  'SheRemoveQuotesA',  \
    SheRemoveQuotesW, <NONE>,  'SheRemoveQuotesW',  \
    SheSetCurDrive, <NONE>,  'SheSetCurDrive',  \
    SheShortenPathA, <NONE>,  'SheShortenPathA',  \
    SheShortenPathW, <NONE>,  'SheShortenPathW',  \
    ShellAboutA, <.hwnd, .szApp, .szOtherStuff, .hIcon>,  'ShellAboutA',  \
    ShellAboutW, <.hwnd, .szApp, .szOtherStuff, .hIcon>,  'ShellAboutW',  \
    ShellExec_RunDLL, <NONE>,  'ShellExec_RunDLL',  \
    ShellExec_RunDLLA, <NONE>,  'ShellExec_RunDLLA',  \
    ShellExec_RunDLLW, <NONE>,  'ShellExec_RunDLLW',  \
    ShellExecuteA, <.hwnd, .lpOperation, .lpFile, .lpParameters, .lpDirectory, .nCmdShow>,  'ShellExecuteA',  \
    ShellExecuteEx, <.lpExecInfo>,  'ShellExecuteEx',  \
    ShellExecuteExA, <.lpExecInfo>,  'ShellExecuteExA',  \
    ShellExecuteExW, <.lpExecInfo>,  'ShellExecuteExW',  \
    ShellExecuteW, <.hwnd, .lpOperation, .lpFile, .lpParameters, .lpDirectory, .nCmdShow>,  'ShellExecuteW',  \
    ShellHookProc, <NONE>,  'ShellHookProc',  \
    ShellMessageBoxA, <NONE>,  'ShellMessageBoxA',  \
    ShellMessageBoxW, <NONE>,  'ShellMessageBoxW',  \
    Shell_GetCachedImageIndex, <NONE>,  'Shell_GetCachedImageIndex',  \
    Shell_GetImageLists, <NONE>,  'Shell_GetImageLists',  \
    Shell_MergeMenus, <NONE>,  'Shell_MergeMenus',  \
    Shell_NotifyIcon, <.dwMessage, .lpData>,  'Shell_NotifyIcon',  \
    Shell_NotifyIconA, <.dwMessage, .lpData>,  'Shell_NotifyIconA',  \
    Shell_NotifyIconW, <.dwMessage, .lpData>,  'Shell_NotifyIconW',  \
    SignalFileOpen, <NONE>,  'SignalFileOpen',  \
    StrChrA, <.lpStart, .wMatch>,  'StrChrA',  \
    StrChrIA, <.lpStart, .wMatch>,  'StrChrIA',  \
    StrChrIW, <.lpStart, .wMatch>,  'StrChrIW',  \
    StrChrW, <.lpStart, .wMatch>,  'StrChrW',  \
    StrCmpNA, <.lpStr1, .lpStr2, .nChar>,  'StrCmpNA',  \
    StrCmpNIA, <.lpStr1, .lpStr2, .nChar>,  'StrCmpNIA',  \
    StrCmpNIW, <.lpStr1, .lpStr2, .nChar>,  'StrCmpNIW',  \
    StrCmpNW, <.lpStr1, .lpStr2, .nChar>,  'StrCmpNW',  \
    StrCpyNA, <NONE>,  'StrCpyNA',  \
    StrCpyNW, <NONE>,  'StrCpyNW',  \
    StrNCmpA, <NONE>,  'StrNCmpA',  \
    StrNCmpIA, <NONE>,  'StrNCmpIA',  \
    StrNCmpIW, <NONE>,  'StrNCmpIW',  \
    StrNCmpW, <NONE>,  'StrNCmpW',  \
    StrNCpyA, <NONE>,  'StrNCpyA',  \
    StrNCpyW, <NONE>,  'StrNCpyW',  \
    StrRChrA, <.lpStart, .lpEnd, .wMatch>,  'StrRChrA',  \
    StrRChrIA, <.lpStart, .lpEnd, .wMatch>,  'StrRChrIA',  \
    StrRChrIW, <.lpStart, .lpEnd, .wMatch>,  'StrRChrIW',  \
    StrRChrW, <.lpStart, .lpEnd, .wMatch>,  'StrRChrW',  \
    StrRStrA, <NONE>,  'StrRStrA',  \
    StrRStrIA, <.lpSource, .lpLast, .lpSrch>,  'StrRStrIA',  \
    StrRStrIW, <.lpSource, .lpLast, .lpSrch>,  'StrRStrIW',  \
    StrRStrW, <NONE>,  'StrRStrW',  \
    StrStrA, <.lpFirst, .lpSrch>,  'StrStrA',  \
    StrStrIA, <.lpFirst, .lpSrch>,  'StrStrIA',  \
    StrStrIW, <.lpFirst, .lpSrch>,  'StrStrIW',  \
    StrStrW, <.lpFirst, .lpSrch>,  'StrStrW',  \
    WOWShellExecute, <NONE>,  'WOWShellExecute',  \
    Win32DeleteFile, <NONE>,  'Win32DeleteFile',  \
    WriteCabinetState, <NONE>,  'WriteCabinetState'
