; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: Win32 specific macros. winproc is procedure for message handling.
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes: Actually these macros are not OS dependent, but their usefulness for other
;         OS is unclear. Maybe they need some refactoring in order to be used OS
;         independently.
;_________________________________________________________________________________________

macro thread_return {
  return
}

;-----------------------------------------
; This file is part of Fresh standard
; macro library.
;-----------------------------------------


macro winproc name, [arg] {
common
  \err@endp

  macro err@endp \{
    end if
    Missing 'endwp' before the procedure.
  \}


  if ~ used name
    if defined options.ShowSkipped & options.ShowSkipped
      display 1,'Message procedure skipped: ',`name, $0d, $0a
    end if
  else

 name:
    .__info.id = 2
    .__info.start = $

  if arg eq
    virtual at ebp+8
      .hwnd dd ?
      .wmsg dd ?
      .wparam dd ?
      .lparam dd ?
      .__info.argsize = 16
    end virtual
  else
    virtual at ebp+8
      forward
        arg dd ?
        if ~ defined name#arg
          ERROR! the argument `arg MUST begin with dot
        end if
      common
        .__info.argsize = $ - ebp - 8
    end virtual
  end if

  if .__info.argsize <> 16
    Error! The count of `name arguments MUST be 4 dwords.
  end if

  virtual at ebp - .__info.commonframe.size
  .__info.commonframe.begin:
}



macro ondefault {  ; begins procedure instructions
common
        dispatch [ebp+12]
.ondefault:
}


macro onmessage message {
  .#message:
  .#message#.__info.id = 3
  .#message#.__info.number = casecounter
  oncase message
}


macro endwp {
common
    .__info.msgcount = casecounter
  enddp
}
