;<ff
Window frmIDEOptions, 3, 0, 'TForm', 'Aliases', $56000000, $10000, 0, 234, 184, 320, 275, IDEOptionsProc;
Window NONE, 0, 5, 'SysListView32', 'ListView', $5001800D, $0, 103, 0, 32, 312, 216, 0;
Window NONE, 3, 3, 'TForm', 'Form', $50800000, $10000, 0, 0, 0, 312, 32, 0;
Window NONE, 0, 0, 'STATIC', 'A&liases:', $50000200, $0, 0, 8, 12, 64, 19, 0;
Window NONE, 0, 0, 'BUTTON', '&Add', $50018000, $0, 100, 96, 8, 64, 19, 0;
Window NONE, 0, 0, 'BUTTON', '&Remove', $50018000, $0, 101, 168, 8, 64, 19, 0;
Window NONE, 2, 0, 'BUTTON', '&Edit', $50018000, $0, 102, 240, 8, 64, 19, 0;
;ff>

winproc IDEOptionsProc
  .lvi LVITEM
begin

.idButtonAdd  = 100
.idButtonDel  = 101
.idButtonEdit = 102
.idListView    = 103


ondefault
        stc
        return

;--------------------------------
; Init columns of the listview
;--------------------------------
onmessage FM_AFTERCREATE
locals
  .lvc LVCOLUMN
endl

cTitleKey text 'Name'
cTitleVal text 'Value'

        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT

        lea     ebx, [.lvc]

        mov     [.lvc.mask], LVCF_FMT or LVCF_TEXT or LVCF_SUBITEM
        mov     [.lvc.fmt], LVCFMT_RIGHT
        mov     [.lvc.pszText], cTitleKey
        mov     [.lvc.iSubItem], 0
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_INSERTCOLUMN, 0, ebx

        mov     [.lvc.mask], LVCF_FMT or LVCF_TEXT or LVCF_SUBITEM
        mov     [.lvc.fmt], LVCFMT_LEFT
        mov     [.lvc.pszText], cTitleVal
        mov     [.lvc.iSubItem], 1
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_INSERTCOLUMN, 1, ebx

        clc
        return


;----------------------------------------------------------
; Loads the path aliases ("environment variables") from
; the .ini file.
;-----------------------------------------------------------
onmessage OM_LOADOPTIONS
        cmp     [.lparam], 0
        je      .readfromini

; read the aliases from array of type TEnvVarType (.lparam is pointer to pointer to TArray)

        mov     esi, [.lparam]
        mov     esi, [esi]
        test    esi, esi
        jz      .sizecols

        mov     ebx, [esi+TArray.count]
        lea     esi, [esi+TArray.array]

.insertloop:
        cmp     ebx, 0
        je      .sizecols

        stdcall StrPtr, [esi+TEnvVarType.pName]
        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iItem], 10000
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], eax
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_INSERTITEM, 0, eax

        mov     [.lvi.iItem], eax
        stdcall StrPtr, [esi+TEnvVarType.pValue]
        mov     [.lvi.pszText], eax
        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iSubItem], 1
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_SETITEM, 0, eax

        add     esi, sizeof.TEnvVarType
        dec     ebx
        jmp     .insertloop


; read the aliases from ini file.
.readfromini:
        stdcall GetMem, 32768          ; get maximum buffer for INI section.
        mov     edi, eax

        stdcall StrPtr, [hIniFileName]
        invoke  GetPrivateProfileSectionA, _section_environment, edi, 32767, eax

; fill "evironment" variables to the listview.
        push    edi

.fillloop:
        mov     esi, edi
        cmp     byte [edi], 0
        je      .endoflist

.scaneq:
        cmp     byte [edi], 0
        je      .endofstring

        cmp     byte [edi], '='
        je      .eqfound

        inc     edi
        jmp     .scaneq

.endofstring:
        inc     edi
        jmp     .fillloop

.eqfound:
        mov     byte [edi],0
        inc     edi

        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iItem], 10000
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], esi
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_INSERTITEM, 0, eax

        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iItem], eax
        mov     [.lvi.iSubItem], 1
        mov     [.lvi.pszText], edi
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_SETITEM, 0, eax

        xor     al,al
        mov     ecx, 32768
        repne scasb
        jmp     .fillloop

.endoflist:
        stdcall FreeMem ; from the stack.

.sizecols:
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_SETCOLUMNWIDTH, 0, LVSCW_AUTOSIZE_USEHEADER
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_SETCOLUMNWIDTH, 1, LVSCW_AUTOSIZE_USEHEADER

        clc
        return

;--------------------------------------------------------------------
; Saves the paths to the .ini file on exit of the dialog with MR_OK
;--------------------------------------------------------------------
onmessage OM_SAVEOPTIONS

locals
  .buffer rb 1024
endl
        cmp     [.lparam], 0
        je      .savetoini

; save to project poVarArray
        mov     esi, [.lparam]

        stdcall EmptyVarList, [.lparam]

        stdcall FreeMem, [esi]
        stdcall CreateArray, sizeof.TEnvVarType
        mov     [esi], eax

        xor     ebx, ebx

.getloop2:
        lea     eax, [.buffer]
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], eax
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_GETITEMTEXT, ebx, eax
        test    eax,eax
        jz      .endofitems2

        stdcall AddArrayItems, [esi], 1
        mov     [esi], edx
        mov     edi, eax

        lea     eax, [.buffer]
        stdcall StrDup, eax
        mov     [edi+TEnvVarType.pName], eax

        lea     eax, [.buffer]
        mov     [.lvi.iSubItem], 1
        mov     [.lvi.pszText], eax
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_GETITEMTEXT, ebx, eax

        lea     eax, [.buffer]
        stdcall StrDup, eax
        mov     [edi+TEnvVarType.pValue], eax

        inc     ebx
        jmp     .getloop2

.endofitems2:
        clc
        return


.savetoini:
        stdcall GetMem, 32768
        mov     edi, eax

        xor     esi, esi

        push    edi

.getloop:
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], edi
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_GETITEMTEXT, esi, eax
        test    eax,eax
        jz      .endofitems

        add     edi, eax
        mov     byte [edi], '='
        inc     edi

        mov     [.lvi.iSubItem], 1
        mov     [.lvi.pszText], edi
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_GETITEMTEXT, esi, eax

        add     edi, eax
        inc     edi
        inc     esi

        jmp     .getloop

.endofitems:
        mov     byte [edi], 0

        pop     edi

        stdcall StrPtr, [hIniFileName]
        invoke  WritePrivateProfileSectionA, _section_environment, edi, eax

        stdcall FreeMem, edi

        clc
        return

;-------------------------------------------------------------
; Well, executes the functions when
; one clicks on buttons "Add", "Edit", etc.
; Uses dialog box from the file "EditPath.frm"
;-------------------------------------------------------------
onmessage WM_COMMAND

        movzx   esi, word [.wparam]

        cmp     esi, .idButtonAdd ; button near include path edit
        je      .addpath

        cmp     esi, .idButtonDel
        je      .delpath

        cmp     esi, .idButtonEdit
        jne     .ondefault

.editpath:
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_GETNEXTITEM, -1, LVNI_SELECTED
        cmp     eax, -1
        jne     .getselected

        clc
        return

.getselected:
        mov     ebx, eax

        stdcall StrNew
        mov     esi, eax
        stdcall StrSetCapacity, esi, 1024
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], eax
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_GETITEMTEXT, ebx, eax
        stdcall StrFixLen, esi

        stdcall StrNew
        mov     edi, eax
        stdcall StrSetCapacity, edi, 1024
        mov     [.lvi.iSubItem], 1
        mov     [.lvi.pszText], eax
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_GETITEMTEXT, ebx, eax
        stdcall StrFixLen, edi

        stdcall InputAliasName, esi, edi
        cmp     eax, MR_OK
        jne     .exitdelstrings

        stdcall StrPtr, esi
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], eax
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_SETITEMTEXT, ebx, eax

        stdcall StrPtr, edi
        mov     [.lvi.iSubItem], 1
        mov     [.lvi.pszText], eax
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_SETITEMTEXT, ebx, eax

.exitdelstrings:
        stdcall StrDel, esi
        stdcall StrDel, edi

        clc
        return

.addpath:
        stdcall StrNew
        mov     esi, eax
        stdcall StrNew
        mov     edi, eax

        stdcall InputAliasName, esi, edi
        cmp     eax, MR_OK
        jne     .exitdelstrings

        stdcall StrPtr, esi
        mov     [.lvi.pszText], eax
        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iItem], 10000
        mov     [.lvi.iSubItem], 0
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_INSERTITEM, 0, eax

        lea     ecx, [.lvi]
        push    ecx
        push    eax
        stdcall StrPtr, edi
        mov     [.lvi.pszText], eax
        mov     [.lvi.iSubItem], 1
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_SETITEMTEXT
        jmp     .exitdelstrings


.delpath:
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_GETNEXTITEM, -1, LVNI_SELECTED
        cmp     eax, -1
        jne     .delselected

        clc
        return

.delselected:
        invoke  SendDlgItemMessageA, [.hwnd], .idListView, LVM_DELETEITEM, eax, 0
        clc
        return
endwp