cHHCtrlLib  text "HHCTRL.OCX"
cHtmlHelpA  text "HtmlHelpA"
;  cFreshHelp    db "%fresh%\"
;  cFreshDefHelp db "doc\freshguide.chm", 0
;  .size = $ - cFreshDefHelp


uglobal
  HtmlHelp     dd ?
  hHHCtrl      dd ?
  ptrHelpFiles dd ?     ; points to array of dwords with handles of strings with help filenames.
endg

proc InitHelp
begin
        invoke  LoadLibraryA, cHHCtrlLib
        mov     [hHHCtrl],eax
        or      eax,eax
        jz      .finish

        invoke  GetProcAddress, eax, cHtmlHelpA

.finish:
        mov     [HtmlHelp],eax
        return
endp



finalize FreeHelpList
begin
        push    esi ebx

        mov     esi, [ptrHelpFiles]
        test    esi, esi
        jz      .endfree

        mov     ebx, [esi+TArray.count]
.cleanloop:
        dec     ebx
        js      .endclean

        stdcall StrDel, [esi+TArray.array+4*ebx]
        jmp     .cleanloop

.endclean:
        stdcall FreeMem, esi
        mov     [ptrHelpFiles], 0

.endfree:
        pop     ebx esi
        return
endp



proc RebuildHelpFilesList
begin
        stdcall FreeHelpList
        stdcall CreateArray, 4
        mov     [ptrHelpFiles], eax

        stdcall ReadSectionFromIni, [hIniFileName], cHelpSection, _AddOneHelpFile, 0
        return
endp



proc _AddOneHelpFile, .ptrName, .dummy
begin
        stdcall StrDup, [.ptrName]
        push    eax
        stdcall AddArrayItems, [ptrHelpFiles], 1
        mov     [ptrHelpFiles], edx
        popd    [eax]
        clc
        return
endp



proc OnHelp, .wparam, .lparam
.filecount dd ?
.str       rb 256
begin
        invoke  SendMessageA, [hEditorsHost], EHM_GETCURRENTASMEDIT, 0, 0
        test    eax, eax
        jz      .finish
        lea     ebx, [.str]
        invoke  SendMessageA, eax, AEM_GETWORDATCARET, 256, ebx

        mov     esi, [ptrHelpFiles]
        test    esi, esi
        jz      .finish

        push    [esi+TArray.count]
        pop     [.filecount]

        cmp     [.filecount], 0
        je      .finish

        xor     edi, edi
.searchloop:
        stdcall SearchOneHelp, [esi+TArray.array+4*edi], ebx, FALSE
        jc     .finish
        inc    edi
        cmp    edi, [.filecount]
        jne    .searchloop

        stdcall SearchOneHelp, [esi+TArray.array+4*edi-4], ebx, TRUE

.finish:
        return
endp



proc SearchOneHelp, .hFileName, .ptrWord, .flagIndex
  .aklink    HH_AKLINK
begin
        push    ebx esi edi

        stdcall StrLen, [.hFileName]
        mov     ecx, eax
        stdcall StrPtr, [.hFileName]

.extloop:
        dec     ecx
        js      .notfound

        cmp     byte [eax+ecx], '.'
        jne     .extloop

        mov     ecx, dword [eax+ecx]    ; get the extension
        or      ecx, $20202000          ; case insensitive

        cmp     ecx, '.hlp'
        je      .winhelp

        cmp     ecx, '.chm'
        je      .htmlhelp

.notfound:
        clc
        pop     edi esi ebx
        return

.htmlhelp:
        cmp     [HtmlHelp], NULL
        je      .notfound

        xor     eax, eax
        mov     [.aklink.cbStruct], sizeof.HH_AKLINK
        mov     [.aklink.fReserved], eax
        mov     [.aklink.pszUrl], eax
        mov     [.aklink.pszMsgText], eax
        mov     [.aklink.pszMsgTitle], eax
        mov     [.aklink.pszWindow], eax

        push    [.ptrWord]
        pop     [.aklink.pszKeywords]

        push    [.flagIndex]
        pop     [.aklink.fIndexOnFail]

        stdcall StrPtr, [.hFileName]
        mov     ebx,eax
        lea     eax, [.aklink]

        mov     ecx, HH_KEYWORD_LOOKUP
        cmp     [eax+HH_AKLINK.pszKeywords], 0
        jne     @f
        mov     ecx, HH_DISPLAY_TOC
@@:
        invoke  HtmlHelp, NULL, ebx, ecx, eax
        test    eax,eax   ; if eax==0 then given word doesn't exist in the help
        jz      .notfound   ;  file - so we search in user defined help file

.found:
        stc
        pop     edi esi ebx
        return


.winhelp:
        stdcall StrPtr, [.hFileName]

        cmp     [.ptrWord], 0
        jne     @f

        invoke  WinHelpA, [hEditorsHost], eax, HELP_FINDER, 0
        jmp     .found

@@:
        invoke  WinHelpA, [hEditorsHost], eax, HELP_PARTIALKEY, [.ptrWord]

        cmp     [.flagIndex], 0
        jne     .found

        invoke  FindWindowA, cWinHelpName, 0
        mov     ebx, eax

        invoke  SendMessageA, ebx, WM_GETTEXTLENGTH, 0, 0
        invoke  IsWindowVisible, ebx
        test    eax, eax
        jnz     .found

        stdcall StrPtr, [.hFileName]
        invoke  WinHelpA, [hEditorsHost], eax, HELP_QUIT, 0

.waitforclose:
        invoke  FindWindowA, cWinHelpName, 0
        test    eax, eax
        jnz     .waitforclose

        jmp     .notfound
endp


cWinHelpName text 'MS_WINHELP'
